#include <bits/extc++.h>
using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define sfor(i, l, r) for (int i = l; i <= r; ++i)
#define bfor(i, r, l) for (int i = r; i >= l; --i)
#define range(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

struct Vect {
    ld x, y;
    Vect(ld _x = 0, ld _y = 0) {
        x = _x;
        y = _y;
    }
    Vect operator-(Vect b) const {
        return Vect(x - b.x, y - b.y);
    }
};

ld Cross(Vect a, Vect b) {
    return a.x * b.y - a.y * b.x;
}

ld Sq(Vect a, Vect b) {
    return (b.x - a.x) * (a.y + b.y) / 2.0;
}

random_device rd;
mt19937 rnd(rd());

struct Node {
    Node *left = nullptr, *right = nullptr, *mleft, *mright;
    Vect vec;
    int pr = rnd();
    ld sum = 0.0;
};

Node *NewNode(Vect vec) {
    Node *node = new Node;
    node->mleft = node->mright = node;
    node->vec = vec;
    return node;
}

Node *root = nullptr;

void Update(Node *v) {
    v->sum = 0.0;
    v->mleft = v->mright = v;
    if (v->left != nullptr) {
        v->sum += v->left->sum + Sq(v->left->mright->vec, v->vec);
        v->mleft = v->left->mleft;
    }
    if (v->right != nullptr) {
        v->sum += v->right->sum + Sq(v->vec, v->right->mleft->vec);
        v->mright = v->right->mright;
    }
}

Node *Merge(Node *u, Node *v) {
    if (u == nullptr)
        return v;
    if (v == nullptr)
        return u;
    if (u->pr > v->pr) {
        u->right = Merge(u->right, v);
        Update(u);
        return u;
    }
    else {
        v->left = Merge(u, v->left);
        Update(v);
        return v;
    }
}

pair<Node *, Node *> Split(Node *v, Vect vec, Vect pt) {
    if (v == nullptr)
        return {nullptr, nullptr};
    if (Cross(vec, v->vec - pt) < 0.0) {
        auto p = Split(v->left, vec, pt);
        v->left = p.second;
        Update(v);
        return {p.first, v};
    }
    else {
        auto p = Split(v->right, vec, pt);
        v->right = p.first;
        Update(v);
        return {v, p.second};
    }
}

Vect Inter(ld k1, ld b1, ld k2, ld b2) {
    if (k1 == k2) {
        while (true) {}
    }
    ld x = (b2 - b1) / (k1 - k2), y = k1 * x + b1;
    return Vect(x, y);
}

void Insert(Vect pt) {
    auto [left, _right] = Split(root, {-1, 1}, pt);
    auto [mid, right] = Split(_right, {1, 1}, pt);
    Vect v1(-1, -1), v2(-1, -1), v3(-1, -1), v4(-1, -1);
    if (mid != nullptr) {
        v1 = left->mright->vec;
        v2 = mid->mleft->vec;
        v3 = mid->mright->vec;
        v4 = right->mleft->vec;
        ld k, b;
        if (v1.x != v2.x) {
            k = (v1.y - v2.y) / (v1.x - v2.x), b = v1.y - v1.x * k;
            left = Merge(left, NewNode(Inter(k, b, -1, pt.x + pt.y)));
        }
        else
            left = Merge(left, NewNode(Vect(v1.x, pt.x + pt.y - v1.x)));
        left = Merge(left, NewNode(pt));
        if (v3.x != v4.x) {
            k = (v3.y - v4.y) / (v3.x - v4.x), b = v3.y - v3.x * k;
            left = Merge(left, NewNode(Inter(k, b, 1, pt.y - pt.x)));
        }
        else
            left = Merge(left, NewNode(Vect(v3.x, pt.y - pt.x + v3.x)));
    }
    else {
        v1 = left->mright->vec;
        v2 = right->mleft->vec;
        if (v1.x != v2.x) {
            ld k = (v1.y - v2.y) / (v1.x - v2.x), b = v1.y - v1.x * k;
            left = Merge(left, NewNode(Inter(k, b, -1, pt.x + pt.y)));
            left = Merge(left, NewNode(pt));
            left = Merge(left, NewNode(Inter(k, b, 1, pt.y - pt.x)));
        }
        else {
            left = Merge(left, NewNode(Vect(v1.x, pt.x + pt.y - v1.x)));
            left = Merge(left, NewNode(pt));
            left = Merge(left, NewNode(Vect(v1.x, pt.y - pt.x + v1.x)));
        }
    }
    root = Merge(left, right);
}

void Pb(Vect pt) {
    root = Merge(root, NewNode(pt));
}

int main() {
    fast;
    cout.precision(2);
    fixed(cout);
    ll n, m;
    int q;
    cin >> n >> m >> q;
    Pb(Vect(0, 0));
    Pb(Vect(0, m));
    Pb(Vect(n, m));
    Pb(Vect(n, 0));
    while (q--) {
        ll x, y;
        cin >> x >> y;
        Insert(Vect(x, y));
        cout << abs(root->sum) << '\n';
    }
}
