#include <bits/stdc++.h>
#define DEBUG false
#define ll long long
#define pl pair<ll,ll>

using namespace std;

ll s;
vector<ll> segLen; // 
vector<pl> segPos; //

int getIdx(ll x) {
    int l = 0, r = s-1;
    while(l <= r) {
        // cout << l << "-" << r << endl;
        int mid = (l+r)/2;
        int alt = segPos[mid].first;
        if(alt == x) {
            return mid;
        } else if(alt > x) {
            r = mid - 1;
        } else {
            l = mid + 1;
        }
    }
    return s;
}

double dif = 0;
ll n, m;

struct Seg {
    ll val = 0, lazy = 0, size, h = 0, mx = 0;
    int l,r,mid;
    Seg *ls, *rs;
    Seg(int l, int r): l(l), r(r), mid((l+r)/2), size((segPos[r-1].second-segPos[l].first)) {
        if(l + 1 < r) {
            ls = new Seg(l, mid);
            rs = new Seg(mid, r);
        }
    }
    void do_lazy() {
        if(lazy > h) {
            h = lazy;
            mx = max(h,mx);
            val = h*size;
            if(l + 1 < r) {
                ls->lazy = max(ls->lazy, lazy);
                rs->lazy = max(rs->lazy, lazy);
            }
        }
        lazy = 0;
    }
    void update(int a, int b, ll x) {
        if(a >= r || b <= l) { return; }
        if(l + 1 == r) {
            h = max(h,max(lazy,x));
            mx = max(h,mx);
            val = h*size;
            lazy = 0;
            return;
        }
        if(a <= l && b >= r) {
            lazy = max(lazy, x);
            do_lazy();
            return;
        }
        do_lazy();
        rs->update(a,b,x);
        val = ls->val + rs->val;
        mx = max(ls->mx, rs->mx);
    }
    ll query(int a, int b) {
        do_lazy();
        if(a >= r || b <= l) { return 0; }
        if(a <= l && b >= r) { return val; }
        return ls->query(a,b) + rs->query(a,b);
    }
    void lock(int a, int b) {
        update(a,b,n);
        dif -= n*size-(double)((segPos[b-1].second+segPos[a].first-m)*size) / 2;
    }
    int lower_bound(ll x) {
        if(l + 1 == r) {
            if(h < x) {
                return r;
            }
            return l;
        }
        if(ls->mx > x) {
            // cout << "left " << ls->mx << endl;
            return ls->lower_bound(x);
        }
        // cout << "right " << ls->mx << endl;
        return rs->lower_bound(x);
    }
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    ll q, x, y; cin >> n >> m >> q;
    vector<pl> qs(q);
    set<ll> pre = {0,m,m+n};
    for(int qi = 0; qi < q; qi ++) {
        cin >> x >> y;
        pre.insert(y-x+n);
        if(x + y - m > 0) {
            pre.insert(m-(x+y-m)+n);
        }
        qs[qi] = {x,y};
    }
    auto it1 = pre.begin(); it1 ++;
    auto it2 = pre.begin();
    s = pre.size() - 1;
    segLen.resize(s);
    segPos.resize(s);
    segLen[0] = *it1 - *it2;
    segPos[0] = {0,*it1 - *it2};
    // if(DEBUG) cout << "{0, " << (*it1 - *it2) << "} " << endl;
    it2 = it1; it1 ++;
    for(int i = 1; it1 != pre.end(); it1 ++, i ++) {
        segLen[i] = *it1 - *it2;
        segPos[i] = {segPos[i-1].second, segPos[i-1].second + *it1 - *it2};
        // if(DEBUG) cout << "{" << segPos[i-1].second << ", " << (segPos[i-1].second + *it1 - *it2) << "} " << endl;
        it2 = it1;
    }
    Seg big(0,s);
    Seg lit(0,s);
    
    ll mr = 0, mra = 0;
    ll ml = 0, mla = 0;
    cout << fixed << setprecision(2);
    for(int qi = 0; qi < q; qi ++) {
        x = qs[qi].first;
        y = qs[qi].second;
        ll zr = y-x+n;
        if(m - zr > mr) {
            mr = m-zr;
            mra = mr*mr;
        }
        ll zl = x+y;
        if(m - zl > ml) {
            ml = m-zl;
            mla = ml*ml;
        }
        // left area * 4: ml^2
        // right area * 4: mr^2
        ll xup = x + y - m; 
        if(xup > 0) {
            int idxup = getIdx((m-xup+n));
            // cout << "d " << getIdx(max(zr,m)) << " " << idxup << endl;
            lit.lock(getIdx(max(zr,m)),idxup+1);
            // cout << "low "  << lit.lower_bound(n-xup) << "S" << " " << s << endl;
            lit.update(idxup,lit.lower_bound(n-xup)+1,n-xup);
        } else {
            // cout << "zr" << zr << endl;
            // cout << getIdx(max(zr,m)) << endl;
            lit.lock(getIdx(max(zr,m)),s);
        }
        // cout << "low "  << big.lower_bound(m+n-x-y) << endl;
        big.update(getIdx(zr),big.lower_bound(m+n-x-y),m+n-x-y);
        double res = (big.query(0,s) - lit.query(0,s) - mla - mra - dif);
        res /= 2;
        // cout << "~~~~~~~~~~~~~~~~~~~\nans: ";
        cout << res << "\n";
        // for(int i = 0; i < s; i ++) {
        //     cout << big.query(i,i+1) << " ";
        // }
        // cout << " == " << big.query(0,s) << endl << "small: ";
        // for(int i = 0; i < s; i ++) {
        //     cout << lit.query(i,i+1) << " ";
        // }
        // cout << " == " << lit.query(0,s) << endl;
        // cout << "dif: " << dif << " | mla: " << mla << " | mra: " << mra << endl; 
    }
    cout << endl;
    return 0;
}
/*
4 3
2
2 2
2 1
*/