#include <iostream>
#include <vector>
#include <string>
#include <queue>


using namespace std;

string bfs(vector<vector<pair<int, int>>>& adjList, vector<vector<pair<int, int>>>& inverseAdjList, int nOfConnections) {
    vector<bool> isConnectionDone(nOfConnections, false);
    queue<int> nextNode;
    nextNode.push(0);
    string output(nOfConnections, '0');
    vector<bool> visited(adjList.size(), false);
    while (!nextNode.empty()) {
        int node = nextNode.front();
        nextNode.pop();
        if (visited[node]) {
            continue;
        }
        visited[node] = true;
        for (pair<int, int> incoming:inverseAdjList[node]) {
            isConnectionDone[incoming.second] = true;
            if (!visited[incoming.first]) {
                nextNode.push(incoming.first);
            }
        }
        for (pair<int, int> outgoing:adjList[node]) {
            if (!isConnectionDone[outgoing.second]) {
                output[outgoing.second] = '1';
                isConnectionDone[outgoing.second] = true;
                if (!visited[outgoing.first]) {
                    nextNode.push(outgoing.first);
                }
            }
        }
    }
    return output;
}

std::string find_reverse(int N, int M, int connections[][2]) {
    vector<vector<pair<int, int>>> adjList(N);
    vector<vector<pair<int, int>>> inverseAdjList(N);
    for (int i = 0; i < M; ++i) {
        adjList[connections[i][0]-1].emplace_back(make_pair(connections[i][1]-1, i));
        inverseAdjList[connections[i][1]-1].emplace_back(make_pair(connections[i][0]-1, i));
    }
    return bfs(adjList, inverseAdjList, M);
}