#include <iostream>
#include <vector>
#include <string>
#include <queue>


using namespace std;

struct Connection {
    int connectedNode;
    bool isInverse;
    int id;
    Connection() {}
    Connection(int m_connectedNode, int m_isInverse, int m_id) {
        connectedNode = m_connectedNode;
        isInverse = m_isInverse;
        id = m_id;
    }
};
string bfs(vector<vector<Connection>>& adjList, int nOfConnections, int connections[][2]) {
    queue<int> nextNode;
    nextNode.push(0);
    string output(nOfConnections, '0');
    vector<bool> visited(adjList.size(), false);
    while (!nextNode.empty()) {
        int node = nextNode.front();
        nextNode.pop();
        if (visited[node]) {
            continue;
        }
        visited[node] = true;
        for (Connection connection:adjList[node]) {
            connections[connection.id][0] = -1;
            connections[connection.id][1] = -1;
            if (connection.isInverse) {
                output[connection.id] = '1';
            }
            if (connections[connection.id][0] != -1) {
                if (!visited[connection.connectedNode]) {
                    nextNode.push(connection.connectedNode);
                }
            }
        }
    }
    return output;
}

std::string find_reverse(int N, int M, int connections[][2]) {
    vector<vector<Connection>> adjList(N);
    for (int i = 0; i < M; ++i) {
        int fromNode = connections[i][0]-1;
        int toNode = connections[i][1]-1;
        adjList[fromNode].emplace_back(Connection(toNode, false, i));
        adjList[toNode].emplace_back(Connection(fromNode, true, i));
    }
    return bfs(adjList, M, connections);
}