#include <iostream>
#include <vector>
#include <string>
#include <queue>


using namespace std;

/*struct Connection {
    int toNode;
    int inverse;
    int id;
    Connection() {}
    Connection(int m_toNode, int m_inverse, int m_id) {
        toNode = m_toNode;
        inverse = m_inverse;
        id = m_id;
    }
};*/
string bfs(vector<pair<vector<pair<int, int>>, bool>>& adjList, vector<vector<pair<int, int>>>& inverseAdjList, int nOfConnections, int connections[][2]) {
    queue<int> nextNode;
    nextNode.push(0);
    string output(nOfConnections, '0');
    while (!nextNode.empty()) {
        int node = nextNode.front();
        nextNode.pop();
        if (adjList[node].second) {
            continue;
        }
        adjList[node].second = true;
        for (pair<int, int> incoming:inverseAdjList[node]) {
            connections[incoming.second][0] = -1;
            connections[incoming.second][0] = -1;
            if (!adjList[incoming.first].second) {
                nextNode.push(incoming.first);
            }
        }
        for (pair<int, int> outgoing:adjList[node].first) {
            if (connections[outgoing.second][0] != -1) {
                output[outgoing.second] = '1';
                connections[outgoing.second][0] = -1;
                connections[outgoing.second][1] = -1;
                if (!adjList[outgoing.first].second) {
                    nextNode.push(outgoing.first);
                }
            }
        }
    }
    return output;
}

std::string find_reverse(int N, int M, int connections[][2]) {
    vector<pair<vector<pair<int, int>>, bool>> adjList(N, make_pair(vector<pair<int, int>>(), false));
    vector<vector<pair<int, int>>> inverseAdjList(N);
    for (int i = 0; i < M; ++i) {
        adjList[connections[i][0]-1].first.emplace_back(make_pair(connections[i][1]-1, i));
        inverseAdjList[connections[i][1]-1].emplace_back(make_pair(connections[i][0]-1, i));
    }
    return bfs(adjList, inverseAdjList, M, connections);
}