#include<string>
#include<vector>
#include<iostream>
#include<queue>
using namespace std;

void BFS(vector<vector<pair<int, int>>>& connection_list, vector<int>& visited, string& result, int node) {
	int color = 1;
	visited[node] = color;
	queue<int> to_check;
	to_check.push(node);
	while (!to_check.empty())
	{
		node = to_check.front();
		to_check.pop();
		for (pair<int,int> connection : connection_list[node])
		{
			int new_node = connection.first;
			if (!visited[new_node])
			{
				visited[new_node] = color;
				to_check.push(new_node);
			}
			else if (visited[new_node] <= visited[node])
			{
				result[connection.second] = '1';
			}
		}
		color++;
	}
}

string find_reverse(int N, int M, int connections[][2]) {
	vector<vector<pair<int, int>>> connection_list;
	vector<int> visited;
	string result;
	connection_list.resize(N);
	visited.resize(N);
	result.resize(M);
	for (int i = 0; i < M; i++) result[i] = '0';
	//input
	for (int i = 0; i < M; i++)
		connection_list[connections[i][0]-1].push_back({ connections[i][1]-1, i });
	//searching
	for (int i = 0; i < N; i++)
	{
		if (!visited[i])
		{
			BFS(connection_list, visited, result, i);
		}
	}
	return result;
}