#include <iostream>
#include <queue>
#include <vector>

#define MAX_N 500000
#define MAX_M 1500000
#define NIL -1

using namespace std;

int dist[MAX_N + 1], viz[MAX_N + 1], rev[MAX_N + 1], q[MAX_N + 1], c[MAX_M][2];
int edge[MAX_N + 1][2], nxt[MAX_M][2];

void bfs( int n, int m, int nod ) {
    int e, f, l;

    dist[nod] = 1;
    f = l = 0;
    q[f] = nod;
    while ( f <= l ) {
        nod = q[f];
        f++;

        viz[nod] = 1;

        e = edge[nod][0];
        while ( e != NIL ) {
            if ( viz[c[e][1]] == 0 ) {
                rev[e] = 1;
                if ( dist[c[e][1]] == 0 ) {
                    dist[c[e][1]] = dist[nod] + 1;
                    l++;
                    q[l] = c[e][1];
                }
            }
            e = nxt[e][0];
        }

        e = edge[nod][1];
        while ( e != NIL ) {
            if ( rev[e] == 0 ) {
                if ( dist[c[e][0]] == 0 ) {
                    dist[c[e][0]] = dist[nod] + 1;
                    l++;
                    q[l] = c[e][0];
                }
            }
            e = nxt[e][1];
        }
    }
}

std::string find_reverse( int n, int m, int connections[][2] ) {
    int i;
    string ans;

    for ( i = 1; i <= n; i++ )
        edge[i][0] = edge[i][1] = NIL;
    for ( i = 0; i < m; i++ ) {
        c[i][0] = connections[i][0];
        c[i][1] = connections[i][1];

        nxt[i][0] = edge[c[i][0]][0];
        edge[c[i][0]][0] = i;

        nxt[i][1] = edge[c[i][1]][1];
        edge[c[i][1]][1] = i;
    }

    bfs( n / 2, m, n );

    ans = "";
    for ( i = 0; i < m; i++ )
        ans += char( rev[i] + '0' );

    return ans;
}