#include <iostream>
#include <queue>
#include <vector>

#define MAX_N 500000
#define MAX_M 1500000
#define NIL -1

using namespace std;

int vizq[MAX_N + 1], viz[MAX_N + 1], q[MAX_N + 1];
int edge[MAX_N + 1][2], nxt[MAX_M][2];

std::string find_reverse( int n, int m, int c[][2] ) {
    int f, l, e, nod, i;
    string ans;

    ans = "";
    for ( i = 1; i <= n; i++ )
        edge[i][0] = edge[i][1] = NIL;
    for ( i = 0; i < m; i++ ) {
        nxt[i][0] = edge[c[i][0]][0];
        edge[c[i][0]][0] = i;

        nxt[i][1] = edge[c[i][1]][1];
        edge[c[i][1]][1] = i;

        ans += '0';
    }

    nod = rand() % n + 1;

    vizq[nod] = 1;
    f = l = 0;
    q[f] = nod;
    while ( f <= l ) {
        nod = q[f];
        f++;

        viz[nod] = 1;

        e = edge[nod][0];
        while ( e != NIL ) {
            if ( viz[c[e][1]] == 0 ) {
                ans[e] = '1';
                if ( vizq[c[e][1]] == 0 ) {
                    vizq[c[e][1]] = 1;
                    l++;
                    q[l] = c[e][1];
                }
            }
            e = nxt[e][0];
        }

        e = edge[nod][1];
        while ( e != NIL ) {
            if ( ans[e] == '0' ) {
                if ( vizq[c[e][0]] == 0 ) {
                    vizq[c[e][0]] = 1;
                    l++;
                    q[l] = c[e][0];
                }
            }
            e = nxt[e][1];
        }
    }

    return ans;
}