#include <iostream>
#include <queue>
#include <vector>

#define MAX_N 500000
#define MAX_M 1500000
#define NIL -1

using namespace std;

int vizq[MAX_N + 1], viz[MAX_N + 1];
int edge[MAX_N + 1], nxt[2 * MAX_M], q[MAX_N + 1];

std::string find_reverse( int n, int m, int c[][2] ) {
    int f, l, e, nod, i;
    string ans;

    ans = "";
    for ( i = 1; i <= n; i++ )
        edge[i] = NIL;
    for ( i = 0; i < m; i++ ) {
        nxt[i] = edge[c[i][0]];
        edge[c[i][0]] = i;

        nxt[i + m] = edge[c[i][1]];
        edge[c[i][1]] = i + m;

        ans += '0';
    }

    nod = n;

    vizq[nod] = 1;
    f = l = 0;
    q[f] = nod;
    while ( f <= l ) {
        nod = q[f];
        f++;

        viz[nod] = 1;

        e = edge[nod];
        while ( e != NIL ) {
            if ( e < m ) {
                if ( viz[c[e][1]] == 0 ) {
                    ans[e] = '1';
                    if ( vizq[c[e][1]] == 0 ) {
                        vizq[c[e][1]] = 1;
                        l++;
                        q[l] = c[e][1];
                    }
                }
            } else {
                e -= m;
                if ( ans[e] == '0' ) {
                    if ( vizq[c[e][0]] == 0 ) {
                        vizq[c[e][0]] = 1;
                        l++;
                        q[l] = c[e][0];
                    }
                }
                e += m;
            }
            e = nxt[e];
        }
    }

    return ans;
}

int main() {
    int n, m, c[100][2], i;

    cin >> n >> m;
    for ( i = 0; i < m; i++ )
        cin >> c[i][0] >> c[i][1];

    cout << find_reverse( n, m, c );

    return 0;
}
