#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
struct seq {
    int sum;
    vector<int> inds;
    bool operator<(const seq& s) {
        return sum < s.sum;
    }
    bool operator==(const seq& s) {
        return sum == s.sum;
    }
};
int n, m;
vector<int> A;
vector<int> B;
vector<seq> getSeqA(int i) {
    if (i == n) {
        return {};
    }
    if (i == n - 1) {
        return { {A[i],{i}},{0,{}} };
    }
    vector<seq> v = getSeqA(i + 1);
    vector<seq> v1(v);
    for (int j = 0; j < v1.size(); j++) {
        v.push_back(v1[j]);
        v[v.size() - 1].sum += A[i];
        v[v.size() - 1].inds.push_back(i);
    }
    return v;
}
vector<seq> getSeqB(int i) {
    if (i == m) {
        return {};
    }
    if (i == m - 1) {
        return { {B[i],{i}},{0,{}} };
    }
    vector<seq> v = getSeqB(i + 1);
    int s = v.size();
    for (int j = 0; j < s; j++) {
        v.push_back(v[j]);
        v[v.size() - 1].sum += B[i];
        v[v.size() - 1].inds.push_back(i);
    }
    return v;
}
struct range {
    int start, end;
    int size() {
        return end - start + 1;
    }
    int middle() {
        return (end + start) / 2;
    }
};
int find(int k, vector<int>& v, range r) {
    if (r.size() == 1) {
        return (r.start + 1) * (k == v[r.start]) - 1;
    }
    int x = v[r.middle()];
    if (x == k)
        return r.middle();
    if (x < k) {
        return find(k, v, { r.middle() + 1,r.end });
    }
    else
        return find(k, v, { r.start,r.middle()});
}
int main()
{
    cin >> n;
    A.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> A[i];
    }
    cin >> m;
    B.resize(m);
    for (int i = 0; i < m; i++) {
        cin >> B[i];
    }
    vector<int> b(B);
    sort(b.begin(), b.end());
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (A[i] <= b[j])
                continue;
            int x = find(A[i] - b[j], b, { 0,m - 1 });
            if (x != -1) {
                for (int k = 0; k < m; k++) {
                    if (B[k] == b[j]) {
                        for (int l = 0; l < m; l++) {
                            if (l != k && B[l] == A[i] - b[j]) {
                                cout << 1 << endl << i << endl << 2 << k << " " << l;
                                return 0;
                            }
                        }
                    }
                }
            }
        }
    }
    vector<int> a(A);
    sort(a.begin(), a.end());
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
            if (B[i] <= a[j])
                continue;
            int x = find(B[i] - a[j], a, { 0,n - 1 });
            if (x != -1) {
                for (int k = 0; k < n; k++) {
                    if (A[k] == a[j]) {
                        for (int l = 0; l < n; l++) {
                            if (l != k && A[l] == B[i] - a[j]) {
                                cout << 2 << endl << k << " " << l << endl << 1 << endl << i;
                                return 0;
                            }
                        }
                    }
                }
            }
        }
    }
    vector<seq> va = getSeqA(0);
    vector<seq> vb = getSeqB(0);
    /*for (int i = 0; i < vb.size(); i++) {
        cout << vb[i].sum << " - ";
        for (int j = 0; j < vb[i].inds.size(); j++) {
            cout << vb[i].inds[j] << " ";
        }
        cout << endl;
    }*/
    sort(va.begin(), va.end());
    sort(vb.begin(), vb.end());
    int i = 0;
    int j = 0;
    while (1) {
        if (va[i] == vb[j] && va[i].sum != 0) {
            cout << va[i].inds.size() << endl;
            for (int k = 0;k < va[i].inds.size();k++) {
                cout << va[i].inds[k] << " ";
            }
            cout << endl;
            cout << vb[j].inds.size() << endl;
            for (int k = 0;k < vb[j].inds.size();k++) {
                cout << vb[j].inds[k] << " ";
            }
            cout << endl;
            break;
        }
        if (va[i] < vb[j]) {
            i++;
        }
        else
            j++;
    }
}