#include <stdio.h>
#include <ctype.h>

#include <algorithm>
#include <set>

// 52% solution, for now

#define area long double
#define ll long long

#define DEBUG if(0) 

static inline ll fgetll(){
  long long n = 0;
  int ch;
  
  while( !isdigit(ch = fgetc(stdin)) );
  do
    n = n * 10 + ch - '0';
  while( isdigit(ch = fgetc(stdin)) );
  
  return n;
}

#define MAXC 1048576
#define MAXD 2097152

struct AINT {
  int size;
  ll st, dr;
  area a;
  int lazy;
  int newval;
} aint[2 * MAXD], aint2[2 * MAXD];

int aintn;
ll w, h;

/*void myqsort( int v[], int begin, int end ){
  int b = begin - 1, e = end + 1;
  ll p = v[(begin + end) / 2], aux;
  
  while( v[++b] < p );
  while( v[--e] > p );
  
  while( b < e ){
    aux = v[b];
    v[b] = v[e];
    v[e] = aux;
    
    while( v[++b] < p );
    while( v[--e] > p );
  }
  
  if( begin < e )
    myqsort(v, begin, e);
  if( e + 1 < end )
    myqsort(v, e + 1, end);
}*/

// propagate lazy
static inline void AINTpropdown( struct AINT aint[], int i ){
  int left = i * 2 + 1, right = i * 2 + 2;

  if( !aint[i].lazy || aint[i].size == 1 )
    return;
  
  aint[left].lazy = aint[right].lazy = 1;
  aint[left].newval = aint[right].newval = aint[i].newval;
  
  if( aint[left].size > 1 ){
    aint[left].a = ((area)(aint[left].dr - aint[left].st)) * aint[left].newval;
  }else
    aint[left].a = aint[left].newval;

  if( aint[right].size > 1 ){
    aint[right].a = ((area)(aint[right].dr - aint[right].st)) * aint[right].newval;
  }else
    aint[right].a = aint[right].newval;
}

static inline area AINTpointquery( struct AINT aint[], ll point ){
  return aint[point + aintn - 1].a;
}

void AINTjoin( struct AINT aint[], int i ){
  int left = i * 2 + 1, right = i * 2 + 2;
  ll mij = (aint[i].st + aint[i].dr) / 2;
  
  AINTpropdown(aint, i);
  
  if( aint[i].size == 1 )
    return;
  
  if( aint[left].size == 1 ){
    aint[i].a = (aint[left].a + aint[right].a) / 2;// trapezoid area
  }else
    aint[i].a =
      aint[left].a + aint[right].a +
      (AINTpointquery(aint, mij) + AINTpointquery(aint, mij + 1)) / 2;

  aint[i].lazy = 0;
  aint[i].size = aint[left].size + aint[right].size;
  aint[i].st = aint[left].st;
  aint[i].dr = aint[right].dr;
  
  //printf("([%lld, %lld] = %d, %Lf) + ([%lld, %lld] = %d, %Lf) = ([%lld, %lld] = %d, %Lf)\n",
  //  aint[left].st, aint[left].dr, aint[left].size, aint[left].a,
  //  aint[right].st, aint[right].dr, aint[right].size, aint[right].a,
  //  aint[i].st, aint[i].dr, aint[i].size, aint[i].a);
}

// lazy update
void AINTset( struct AINT aint[], ll st, ll dr, ll newval, int root ){
  int left = root * 2 + 1, right = root * 2 + 2;
  
  if( aint[root].size == 1 ){// point update
    aint[root].newval = newval;
    return;
  }
  
  if( aint[root].st >= dr || aint[root].dr <= st )// disjunct
    return;
  
  if( aint[root].st >= st && aint[root].dr <= dr ){// included
    aint[root].lazy = 1;
    aint[root].newval = newval;
    aint[root].a = ((area)(aint[root].dr - aint[root].st)) * newval;
    return;
  }
  
  AINTset(aint, st, dr, newval, left);
  AINTset(aint, st, dr, newval, right);
  AINTjoin(aint, root);
}

area AINTquery( struct AINT aint[], ll st, ll dr, int root ){
  ll mij = (aint[root].st + aint[root].dr / 2);
  area r1, r2, r;
  
  DEBUG printf("[%lld, %lld]  [%lld, %lld] = %Lf -> ", st, dr, aint[root].st, aint[root].dr, aint[root].a);
  if( aint[root].st >= dr || aint[root].dr <= st ){
    DEBUG printf("disjunct\n");
    return 0;
  }
  if( aint[root].st >= st && aint[root].dr <= dr ){
    DEBUG printf("included\n");
    return aint[root].a;
  }

  DEBUG printf("recurse\n");

  AINTpropdown(aint, root);// pass down lazy
  
  
  r1 = AINTquery(aint, st, dr, root * 2 + 1);
  r2 = AINTquery(aint, st, dr, root * 2 + 2);
  r = r1 + r2;

  if( mij >= st && dr >= mij + 1 ){
    DEBUG printf("extra: (%lld = %Lf, %lld = %Lf)\n", mij, AINTpointquery(aint, mij), mij + 1, AINTpointquery(aint, mij + 1));
    r += (AINTpointquery(aint, mij) + AINTpointquery(aint, mij + 1)) / 2;
  }
  
  DEBUG printf("returning %Lf\n", r);
  
  return r;
}

area insert( int x, int y ){
  DEBUG printf("+(%d, %d)\n", x, y);
  int d1 = x + y, d2 = x + h - y;
  int d11 = AINTpointquery(aint2, d2);
  area a;
  
  DEBUG printf("d1 = %d | d2 = %d | d11 = %d\n", d1, d2, d11);
  
  //for( int i = 0; i < aintn * 2 - 1 ; i++ ){
  //  printf("[%lld, %lld] = %Lf\n", aint[i].st, aint[i].dr, aint[i].a);
  //}
  
  a = AINTquery(aint, d11, d1, 0);
  DEBUG printf("a = %Lf\n", a);
  a -= ((area)(d2 - h)) * (d1 - d11);
  DEBUG printf("a = %Lf\n", a);
  
  AINTset(aint2, d2, h + AINTpointquery(aint, d1), d1, 0);
  AINTset(aint, d11, d1, d2 - h, 0);

  return a;
}

int main(){
  int n, i;
  ll ndiag, qx, qy;
  area acc = 0;
  
  w = fgetll();
  h = fgetll();
  ndiag = w + h + 1;
  
  DEBUG printf("ok | w = %lld | h = %lld | ndiag = %lld\n", w, h, ndiag);

  aintn = 1;
  while( aintn < ndiag )
    aintn <<= 1;
  
  DEBUG printf("ok | aintn = %d\n", aintn);

  // aint[]
  for( i = 0 ; i < ndiag ; i++ ){
    aint[i + aintn - 1].st = aint[i + aintn - 1].dr = i;
    aint[i + aintn - 1].size = 1;
    
    if( i <= w )
      aint[i + aintn - 1].a = i;
    else
      aint[i + aintn - 1].a = w + h - i;
    
    aint[i + aintn - 1].lazy = aint[i + aintn - 1].newval = 0;
  }
  for( ; i < aintn ; i++ ){
    aint[i + aintn - 1].st = aint[i + aintn - 1].dr = i;
    aint[i + aintn - 1].size = 1;
  }

  // build aint[]
  for( i = aintn - 1 ; i-- ; )
    AINTjoin(aint, i);
  
  DEBUG printf("ok\n");

  // aint2[]
  for( i = 0 ; i < ndiag ; i++ ){
    aint2[i + aintn - 1].st = aint2[i + aintn - 1].dr = i;
    aint2[i + aintn - 1].size = 1;
    
    if( i <= h )
      aint2[i + aintn - 1].a = -(i - h);
    else
      aint2[i + aintn - 1].a = (i - h);
    
    aint2[i + aintn - 1].lazy = aint2[i + aintn - 1].newval = 0;
  }
  for( ; i < aintn ; i++ ){
    aint2[i + aintn - 1].st = aint2[i + aintn - 1].dr = i;
    aint2[i + aintn - 1].size = 1;
  }
  
  // build aint2[]
  for( i = aintn - 1 ; i-- ; )
    AINTjoin(aint2, i);
    
  DEBUG printf("ok\n");

  acc = ((area)w) * h;
  n = fgetll();
  for( i = 0 ; i < n ; i++ ){
    qx = fgetll();
    qy = fgetll();
    acc -= (insert(qx, qy));
    printf("%Lf\n", acc);
  }
  
  DEBUG printf("ok\n");
  
  return 0;
}


