#include <iostream>
#include <string>
#include <vector>
#include <stack>
#include <tuple>
#include <list>
using namespace std;

int LAST_NOT_PAINTED = 0;

void Next(vector<list<pair<int, int>>>& graph, vector<bool> now, vector<bool>& painted, stack<int>& route, string& res) {
	int current = route.top();

	painted[current] = true;
	if ((current - LAST_NOT_PAINTED) == 1) LAST_NOT_PAINTED = current + 1;
	now[current] = true;
	while(!graph[current].empty())
	{
		int node = graph[current].front().first;
		int connection = graph[current].front().second;
		if (now[node]) {
			res[connection] = '1';
		}
		if (!painted[node]) {
			route.push(node);
			Next(graph, now, painted, route, res);
		}
		graph[current].pop_front();
	}
	now[current] = false;
	route.pop();
}

string find_reverse(int N, int M, int connections[][2]) {
	vector<list<pair<int, int>>> graph(N);
	for (int i = 0; i < M; i++)
	{
		graph[connections[i][0]-1].push_back(make_pair(connections[i][1]-1, i));
	}
	string res(M, '0');
	vector<bool> painted(N);
	vector<bool> painted_now(N);
	stack<int> route;
	for (int i = 0; i < N; LAST_NOT_PAINTED++)
	{
		if (LAST_NOT_PAINTED < N ) i = LAST_NOT_PAINTED;
		else {
			break;
		}

		if (!painted[i]) {
			route.push(i);
			Next(graph, painted_now, painted, route, res);
		}

	}
	return res;
}
/*
int main() {
	int N = 6;
	int M = 12;
	int connections[12][2] = { {1,2} , {1,5}, {2,3}, {2,5} , {3,4}, {3,6} , {4,1}, {4,5}, {5,3}, {5,6}, {6,1}, {6,4} };
	cout << find_reverse(N, M, connections);
}
*/