﻿#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const long long R = 1LL << 40;

struct node {
    long long nl, nr;

    long long mx, mx2;

    long long sum;

    node *l, *r;

    node(long long ll, long long rr) {
        nl = ll, nr = rr;
        l = r = nullptr;
        mx = 0;
        mx2 = -1;
        sum = 0;
    }
};

void build(int n, int m, node *root) {
    if (root->nl >= n + m) {
        return;
    }
    if (root->nl + 1 == root->nr) {
        if (root->nl <= n) {
            root->sum = n - root->nl;
        } else {
            root->sum = root->nl - n;
        }
        if (root->nl <= m) {
            root->mx = n + m - root->nl;
        } else {
            root->mx = n + m - (root->nl - m);
        }
        return;
    }
    long long nm = (root->nl + root->nr) / 2;
    root->l = new node(root->nl, nm);
    root->r = new node(nm, root->nr);
    build(n, m, root->l);
    build(n, m, root->r);
    vector<long long> v = {root->l->mx, root->r->mx, root->l->mx2, root->r->mx2};
    sort(v.begin(), v.end());
    v.resize(unique(v.begin(), v.end()) - v.begin());
    reverse(v.begin(), v.end());
    root->mx = v[0];
    root->mx2 = v[1];
    root->sum = root->l->sum + root->r->sum;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    long long n, m;
    cin >> n >> m;
    node *root = new node(0, R);
    build(n, m, root);
    vector<vector<long long>> a(n, vector<long long>(4, m));
    long long ans = n * m * 4;
    int q;
    cin >> q;
    while (q--) {
        long long x, y;
        cin >> x >> y;
        for (long long i = x - 1; i >= 0; --i) {
            long long j = (x + y - 1) - i;
            if (j == m) {
                break;
            }
            ans -= (a[i][0] + a[i][1] + a[i][2] + a[i][3]);
            if (0 <= j && j <= m) {
                a[i][2] = min(a[i][2], j);
                a[i][3] = min(a[i][3], j);
                if (j + 1 <= m) {
                    a[i][0] = min(a[i][0], j + 1);
                    a[i][1] = min(a[i][1], j + 1);
                }
            }
            ans += (a[i][0] + a[i][1] + a[i][2] + a[i][3]);
        }
        for (long long i = x; i < n; ++i) {
            long long j = i - (x - y);
            if (j == m) {
                break;
            }
            ans -= (a[i][0] + a[i][1] + a[i][2] + a[i][3]);
            if (0 <= j && j <= m) {
                a[i][1] = min(a[i][1], j);
                a[i][2] = min(a[i][2], j);
                if (j + 1 <= m) {
                    a[i][0] = min(a[i][0], j + 1);
                    a[i][3] = min(a[i][3], j + 1);
                }
            }
            ans += (a[i][0] + a[i][1] + a[i][2] + a[i][3]);
        }
        cout << ans / 4 << ".";
        if (ans % 4 == 0) {
            cout << "00";
        } else {
            cout << ans % 4 * 25;
        }
        cout << '\n';
    }
    return 0;
}