﻿#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const long long R = 1LL << 40;

long long n, m;

struct node {
    long long nl, nr;

    long long mx, mx2, cnt;

    long long sum, sum2, ans;

    node *l, *r;

    node(long long ll, long long rr) {
        nl = ll, nr = rr;
        l = r = nullptr;
        mx = cnt = 0;
        mx2 = -1;
        sum = ans = sum2 = 0;
    }
};

void build(node *root) {
    if (root->nl >= n + m) {
        return;
    }
    if (root->nl + 1 == root->nr) {
        if (root->nl < n) {
            root->sum = n - root->nl - 1;
        } else {
            root->sum = root->nl - n;
        }
        root->sum *= 2;
        root->sum += 1;
        if (root->nl < m) {
            root->mx = n + m - (m - root->nl) + 1;
        } else {
            root->mx = n + m - (root->nl - m);
        }
        root->mx *= 2;
        root->mx -= 1;
        root->sum2 = root->mx;
        root->ans = root->sum2 - root->sum;
        root->cnt = 1;
        return;
    }
    long long nm = (root->nl + root->nr) / 2;
    root->l = new node(root->nl, nm);
    root->r = new node(nm, root->nr);
    build(root->l);
    build(root->r);
    vector<long long> v = {root->l->mx, root->r->mx, root->l->mx2, root->r->mx2};
    sort(v.begin(), v.end());
    v.resize(unique(v.begin(), v.end()) - v.begin());
    reverse(v.begin(), v.end());
    root->mx = v[0];
    root->mx2 = v[1];
    root->sum2 = root->l->sum2 + root->r->sum2;
    root->sum = root->l->sum + root->r->sum;
    root->ans = root->sum2 - root->sum;
    root->cnt = 0;
    if (root->l->mx == root->mx) {
        root->cnt += root->l->cnt;
    }
    if (root->r->mx == root->mx) {
        root->cnt += root->r->cnt;
    }
}

void change(long long ql, long long qr, long long val, node *root) {
    if (qr <= root->nl || root->nr <= ql || root->mx <= val) {
        return;
    }
    if (ql <= root->nl && root->nr <= qr && root->mx2 < val) {
        root->sum2 -= root->mx * root->cnt;
        root->mx = val;
        root->sum2 += root->mx * root->cnt;
        root->ans = root->sum2 - root->sum;
        return;
    }
    change(ql, qr, val, root->l);
    change(ql, qr, val, root->r);
    vector<long long> v = {root->l->mx, root->r->mx, root->l->mx2, root->r->mx2};
    sort(v.begin(), v.end());
    v.resize(unique(v.begin(), v.end()) - v.begin());
    reverse(v.begin(), v.end());
    root->mx = v[0];
    root->mx2 = v[1];
    root->sum2 = root->l->sum2 + root->r->sum2;
    root->ans = root->sum2 - root->sum;
    root->cnt = 0;
    if (root->l->mx == root->mx) {
        root->cnt += root->l->cnt;
    }
    if (root->r->mx == root->mx) {
        root->cnt += root->r->cnt;
    }
}

void change2(long long ql, long long qr, node *root) {
    if (qr <= root->nl || root->nr <= ql) {
        return;
    }
    if (ql <= root->nl && root->nr <= qr) {
        root->sum2 = root->sum;
        root->ans = 0;
        root->mx = 0;
        root->mx2 = -1;
        return;
    }
    change2(ql, qr, root->l);
    change2(ql, qr, root->r);
    vector<long long> v = {root->l->mx, root->r->mx, root->l->mx2, root->r->mx2};
    sort(v.begin(), v.end());
    v.resize(unique(v.begin(), v.end()) - v.begin());
    reverse(v.begin(), v.end());
    root->mx = v[0];
    root->mx2 = v[1];
    root->sum2 = root->l->sum2 + root->r->sum2;
    root->ans = root->sum2 - root->sum;
    root->cnt = 0;
    if (root->l->mx == root->mx) {
        root->cnt += root->l->cnt;
    }
    if (root->r->mx == root->mx) {
        root->cnt += root->r->cnt;
    }
}

long long get_r(long long x, long long y) {
    long long i = n;
    long long j = i - (x - y);
    if (j <= m) {
        return n + j;
    } else {
        j = m;
        i = j + (x - y);
        return m + i;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m;
    node *root = new node(0, R);
    build(root);
    int q;
    cin >> q;
    while (q--) {
        long long x, y;
        cin >> x >> y;
        change(x + y, get_r(x, y), (n + y - x) * 2, root);
        long long i = n;
        long long j = i - (x - y);
        if (j < m) {
            change2(get_r(x, y), R, root);
        }
        long long val = root->ans;
        cout << val / 4 << ".";
        if (val % 4 == 0) {
            cout << "00";
        } else {
            cout << val % 4 * 25;
        }
        cout << '\n';
    }
    return 0;
}