#include <iostream>
#include <bitset>
#include <map>
#include <cassert>
#include <vector>
using namespace std;
using ll = long long;

const int MAXN = 401;
int a[MAXN];
vector<int> compra[MAXN];
int b[MAXN];
vector<int> comprb[MAXN];

bitset<MAXN * MAXN> dpa[MAXN];
bitset<MAXN * MAXN> dpb[MAXN];

vector<int> merge(vector<int> v1, vector<int> v2) {
    for (auto x : v2)
        v1.push_back(x);
    return v1;
}

vector<pair<ll, vector<int>>> input() {
    int n;
    cin >> n;
    map<ll, vector<vector<int>>> mp;
    for (int i = 0; i < n; ++i) {
        ll x;
        cin >> x;
        mp[x].push_back({i});
    }
    ll x0 = -1;
    while (x0 < mp.rbegin()->first) {
        auto& [x, comprs] = *mp.upper_bound(x0);
        while (comprs.size() >= 3) {
            vector<int> v1 = comprs.back();
            comprs.pop_back();
            vector<int> v2 = comprs.back();
            comprs.pop_back();
            mp[x * 2].push_back(merge(v1, v2));
        }
        x0 = x;
    }
    vector<pair<ll, vector<int>>> ans;
    for (auto [x, comprs] : mp) {
        for (auto v : comprs) {
            ans.push_back({x, v});
        }
    }
    return ans;
}

void goback(int i, int sma, int smb, vector<int>& inca, vector<int>& incb, int n, int m) {
    if (i == -1)
        return;
    if (i == 0) {
        if (sma) {
            for (auto t : compra[i])
                inca.push_back(t);
        }
        if (smb) {
            for (auto t : comprb[i])
                incb.push_back(t);
        }
        return;
    }
    if (i < n && !dpa[i - 1][sma]) {
        for (auto t : compra[i])
            inca.push_back(t);
        sma -= a[i];
    }
    if (i < m && !dpb[i - 1][smb]) {
        for (auto t : comprb[i])
            incb.push_back(t);
        smb -= b[i];
    }
    goback(i - 1, sma, smb, inca, incb, n, m);
}

signed main() {
    vector<pair<ll, vector<int>>> a_ = input();
    ll n = a_.size();
    for (int i = 0; i < n; ++i) {
        a[i] = a_[i].first;
        compra[i] = a_[i].second;
    }

    vector<pair<ll, vector<int>>> b_ = input();
    ll m = b_.size();
    for (int i = 0; i < m; ++i) {
        b[i] = b_[i].first;
        comprb[i] = b_[i].second;
    }

    //for (int i = 0; i < n; ++i) {
        //cout << a[i] << ": ";
        //for (auto x : compra[i])
            //cout << x << ' ';
        //cout << endl;
    //}
    //cout << "---" << endl;
    //for (int i = 0; i < m; ++i) {
        //cout << b[i] << ": ";
        //for (auto x : comprb[i])
            //cout << x << ' ';
        //cout << endl;
    //}

    dpa[0][0] = dpa[0][a[0]] = 1;
    for (int i = 1; i < n; ++i) {
        dpa[i] = dpa[i - 1] | (dpa[i - 1] << a[i]);
    }
    dpb[0][0] = dpb[0][b[0]] = 1;
    for (int i = 1; i < m; ++i) {
        dpb[i] = dpb[i - 1] | (dpb[i - 1] << b[i]);
    }

    for (int k = 1; k <= n * m; ++k) {
        if (dpa[n - 1][k] && dpb[m - 1][k]) {
            vector<int> b0;
            vector<int> a0;
            goback(n + m, k, k, a0, b0, n, m);
            cout << a0.size() << endl;
            for (auto x : a0)
                cout << x << ' ';
            cout << endl;
            cout << b0.size() << endl;
            for (auto x : b0)
                cout << x << ' ';
            cout << endl;
            //cout << endl;
            return 0;
        }
    }
}
