#include <iostream>
#include <bitset>
#include <algorithm>
#include <map>
#include <deque>
#include <cassert>
#include <vector>
using namespace std;
using ll = long long;

const ll MAXN = 1000000;
const ll MAXM = 100000;
ll a[MAXN];
ll b[MAXN];

vector<bitset<MAXM>> dpa;
vector<bitset<MAXM>> dpb;

void add(vector<ll>& v, vector<ll>& add) {
    for (auto x : add)
        v.push_back(x);
}

void goback(ll i, ll sma, ll smb, vector<ll>& inca, vector<ll>& incb, ll n, ll m) {
    if (i == -1)
        return;
    if (i == 0) {
        if (sma) {
            inca.push_back(i);
        }
        if (smb) {
            incb.push_back(i);
        }
        return;
    }
    if (i < n && !dpa[i - 1][sma]) {
        inca.push_back(i);
        sma -= a[i];
    }
    if (i < m && !dpb[i - 1][smb]) {
        incb.push_back(i);
        smb -= b[i];
    }
    goback(i - 1, sma, smb, inca, incb, n, m);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll n;
    cin >> n;
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }

    ll m;
    cin >> m;
    for (ll i = 0; i < m; ++i) {
        cin >> b[i];
    }
    for (int i = 0; i < n; ++i) {
        int j = lower_bound(b, b + m, a[i]) - b;
        if (a[i] == b[j]) {
            cout << 1 << endl << i << endl << 1 << endl << j << endl;
            return 0;
        }
    }

    dpa.push_back(0);
    dpb.push_back(0);
    dpa[0][0] = dpa[0][a[0]] = 1;
    dpb[0][0] = dpb[0][b[0]] = 1;

    for (ll i = 1; i < n || i < m; ++i) {
        dpa.push_back(dpa[i - 1] | (dpa[i - 1] << a[i]));
        dpb.push_back(dpb[i - 1] | (dpb[i - 1] << b[i]));
        if ((dpa[i] & dpb[i]).count() > 1) {
            for (ll k = 1; k < MAXM; ++k) {
                if (dpa[i][k] && dpb[i][k]) {
                    vector<ll> a0;
                    vector<ll> b0;
                    goback(i, k, k, a0, b0, n, m);
                    cout << a0.size() << endl;
                    for (auto x : a0)
                        cout << x << ' ';
                    cout << endl;
                    cout << b0.size() << endl;
                    for (auto x : b0)
                        cout << x << ' ';
                    cout << endl;
                    return 0;
                }
            }
        }
    }
}
