#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 605;
const int MAXS = MAXN * MAXN;

int a[MAXN];
int b[MAXN];

int fromA[MAXN][MAXS], fromB[MAXN][MAXS];
int posA[MAXS], posB[MAXS];

void solve( int pos[MAXS], int from[MAXN][MAXS], int x[], int n, int m ) {
  int maxs = n * m;
  for ( int i = 1; i <= n; ++i ) {
    for ( int s = 0; s <= maxs; ++s ) {
      from[i][s] = -1;
      pos[s] = -1;
    }
  }
  pos[x[1]] = 1;
  for ( int i = 2; i <= n; ++i ) {
    for ( int s = x[i] + 1; s <= maxs; ++s ) {
      from[i][s] = pos[s - x[i]];
    }
    for ( int s = x[i] + 1; s <= maxs; ++s ) {
      if ( from[i][s] != -1 ) {
        pos[s] = i;
      }
    }
    pos[x[i]] = i;
    from[i][x[i]] = -1;
  }
}

void printSeq( int n, int m ) {
  int best = 0;
  for ( int s = 1; s <= n * m; ++s ) {
    if ( posA[s] != -1 && posB[s] != -1 ) {
      best = s;
      break;
    }
  }

  vector<int> sol;

  int q = best, p = posA[best], o;
  sol.push_back( p );
  while ( fromA[p][q] != -1 ) {
    o = p;
    p = fromA[p][q];
    q -= a[o];
    sol.push_back( p );
  }

  reverse( sol.begin(), sol.end() );
  cout << sol.size() << "\n";
  for ( int i = 0; i < sol.size(); ++i ) {
    cout << sol[i] - 1 << " ";
  }
  cout << "\n";

  sol.clear();
  q = best, p = posB[best];
  sol.push_back( p );
  while ( fromB[p][q] != -1 ) {
    o = p;
    p = fromB[p][q];
    q -= b[o];
    sol.push_back( p );
  }

  reverse( sol.begin(), sol.end() );
  cout << sol.size() << "\n";
  for ( int i = 0; i < sol.size(); ++i ) {
    cout << sol[i] - 1 << " ";
  }
}

int main() {
  int n, m;

  cin >> n;
  for ( int i = 1; i <= n; ++i ) {
    cin >> a[i];
  }
  cin >> m;
  for ( int i = 1; i <= m; ++i ) {
    cin >> b[i];
  }
  solve(posA, fromA, a, n, m);
  solve(posB, fromB, b, m, n);

  printSeq( n, m );
  return 0;
}
