#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

enum Dir {
	DOWN,
	FLAT,
	UP
};

struct Cell {
	ll height;
	Dir dir;
	Cell()
		:height(0), dir(Dir::FLAT) {
	}
};

struct Paper {
	ll n, m;
	vector<Cell> cells;
	Paper(ll n, ll m)
		:n(n), m(m) {
		cells.resize(n);
	}

	void replace_cell(ll x, ll h, Dir dir) {
		if (h > cells[x].height) {
			cells[x].height = h;
			cells[x].dir = dir;
		} else if (h == cells[x].height && dir > cells[x].dir) {
			cells[x].height = h;
			cells[x].dir = dir;
		}
	}

	void cut(ll x, ll y) {
		y = m + 1 - y;
		for (ll i{ x }, h{ y - 1 }; i <= n; ++i) {
			replace_cell(i, h, Dir::DOWN);
			--h;
		}

		for (ll i{ x-1 }, h{ y - 2 }; i >= 0; --i) {
			replace_cell(i, h, Dir::UP);
			--h;
		}
	}

	double cut_area() {
		double area{ 0.0 };
		for (Cell& cell : cells) {
			switch (cell.dir) {
				case Dir::UP:
				area += cell.height + 0.5;
				break;
				case Dir::DOWN:
				area += cell.height - 0.5;
				break;
				case Dir::FLAT:
				area += cell.height;
				break;
			}
		}
		return area;
	}

	double area() {
		return n * m - cut_area();
	}
};

struct CuttingReqs {
	Paper p;
	CuttingReqs(ll n, ll m)
		:p(n, m) {
	}

	void next() {
		ll x, y;
		cin >> x >> y;
		p.cut(x, y);
		double a{ p.area() };
		cout << (int)(a) << '.' << (int)(10 * (a - (int)(a))) << (int)(100 * (a - (int)(a))) % 10 << '\n';
	}
};

int main() {
	ll n, m;
	cin >> n >> m;
	ll q;
	cin >> q;
	CuttingReqs cutter(n, m);

	for (ll i{ 0 }; i < q; ++i) {
		cutter.next();
	}
}
