#include <stdio.h>
#include <algorithm>

#define MAXN 1000000

using namespace std;

struct pairs{
    int nr;
    int loc;
};
pairs f[MAXN];
pairs s[MAXN];

bool cmp(pairs a, pairs b) {
    return a.nr < b.nr;
}

bool inN[MAXN];
bool inM[MAXN];

int bsearchn(int number, int sizev) {
    int m, st, dr;

    st = 0;
    dr = sizev;

    while ( dr - st > 1 ) {
        m = (dr + st) / 2;
        if ( f[m].nr > number )
            dr = m;
        else
            st = m;
    }

    if ( f[st].nr < number && st < sizev - 1 )
        st++;

    return st;
}

int bsearchm(int number, int sizev) {
    int m, st, dr;

    st = 0;
    dr = sizev;

    while ( dr - st > 1 ) {
        m = (dr + st) / 2;
        if ( s[m].nr > number )
            dr = m;
        else
            st = m;
    }

    if ( s[st].nr < number && st < sizev - 1 )
        st++;

    return st;
}

int main() {
    int n, m, i, pos, totnrn, totnrm;

    unsigned long long sn, sm, dif;

    scanf("%d", &n);

    sn = sm = 0;

    for ( i = 0; i < n; i++ ) {
        scanf("%d", &f[i].nr);
        f[i].loc = i;
        sn += f[i].nr;
    }

    sort(f, f + n, cmp);

    scanf("%d", &m);

    for ( i = 0; i < m; i++ ) {
        scanf("%d", &s[i].nr);
        s[i].loc = i;
        sm += s[i].nr;
    }

    sort(s, s + m, cmp);

    totnrn = n;
    totnrm = m;

    while ( sn != sm && sn > 0 && sm > 0 ) {
        while ( sn > sm ) {
            dif = sn - sm;
            pos = bsearchn(dif, n);
            sn -= f[pos].nr;
            inN[f[pos].loc] = 1;
            totnrn--;
        }

        while ( sm > sn ) {
            dif = sm - sn;
            pos = bsearchm(dif, m);
            sm -= s[pos].nr;
            inM[s[pos].loc] = 1;
            totnrm--;
        }
    }

    printf("%d\n", totnrn);
    for ( i = 0; i < n; i++ ) {
        if ( inN[i] == 0 ) {
            printf("%d ", i);
        }
    }
    printf("\n%d\n", totnrm);
    for ( i = 0; i < m; i++ ) {
        if ( inM[i] == 0 )
            printf("%d ", i);
    }
    printf("\n");
    return 0;
}
