#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <sstream>

using namespace std;

typedef long long ll;
typedef long double ld;

struct Coord
{
    ll x;
    ll y;

    bool operator< (const Coord& c) const
    {
        if (x == c.x)
            return y < c.y;
        return x < c.x;
    }
};

int main()
{
    ll n, m;
    cin >> n >> m;
    n *= 2;
    m *= 2;
    ll q;
    cin >> q;
    vector<ll> bound(n + 1, m);
    for (int i = 0; i < q; ++i)
    {
        ll xx, yy;
        cin >> xx >> yy;
        xx *= 2;
        yy *= 2;
        ll x = xx, y = yy;
        while (x >= 0 && y <= m)
        {
            if (bound[x] == y)
                break;
            bound[x] = y;
            ++y;
            --x;
        }
        x = xx + 1;
        y = yy + 1;
        while (x <= n && y <= m)
        {
            if (bound[x] == y)
                break;
            bound[x] = y;
            ++y;
            ++x;
        }
        ld newplace = 0;
        for (int i = 0; i < n; ++i)
        {
            newplace += min(bound[i], bound[i + 1]);
            if (bound[i] != bound[i + 1])
            {
                newplace += 0.5;
            }
        }
        newplace /= 2;
        newplace /= 2;
        string s = to_string(newplace);
        int ii = 0;
        bool point = false;
        for (; ii < s.size(); ++ii)
        {
            if (s[ii] == '.')
            {
                point = true;
                if (ii >= s.size() - 2)
                    s.push_back('0');
                s.resize(ii + 3);
                break;
            }
        }
        if (!point)
        {
            s.push_back('.');
            s.push_back('0');
            s.push_back('0');
        }
        cout << s << '\n';
    }
    return 0;
}