#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <sstream>

using namespace std;

typedef long long ll;
typedef long double ld;

struct Coord
{
    ll x;
    ll y;

    bool operator< (const Coord& c) const
    {
        if (x == c.x)
            return y < c.y;
        return x < c.x;
    }
};

struct Node
{
    ll place;
    ll bound; //-1 -- different bounds
    ll boundmodifier; //-1 -- nonemod
    short boundup; //-1 -- bound down, 0 -- bound horizontal, 1 -- boundup, 2 -- different bounds
};

class SegmentTree
{
public:
    void build(ll n, ll m, ll left, ll right, int ind = 1, bool st = true)
    {
        if (st)
        {
            tree.resize(4 * n);
        }
        if (left == right - 1)
        {
            tree[ind].place = m;
            tree[ind].bound = m;
            tree[ind].boundup = 0;
            tree[ind].boundmodifier = -1;
            return;
        }
        build(n, m, left, (right + left) / 2, child_1(ind), false);
        build(n, m, (right + left) / 2, right, child_2(ind), false);
        tree[ind].place = tree[child_1(ind)].place + tree[child_2(ind)].place;
        tree[ind].boundup = 0;
        tree[ind].boundmodifier = -1;
        if (tree[child_1(ind)].bound != tree[child_2(ind)].bound)
        {
            tree[ind].bound = -1;
        }
        else
        {
            tree[ind].bound = tree[child_1(ind)].bound;
        }
    }

    ll get_place(ll left, ll right, ll l, ll r, int ind = 1)
    {
        if (left == l && right == r)
            return tree[ind].place;

        if (tree[ind].boundmodifier != -1)
        {

        }
    }
private:
    vector<Node> tree;

    int child_1(int ind)
    {
        return ind * 2;
    }

    int child_2(int ind)
    {
        return ind * 2 + 1;
    }
};

int main()
{
    ll n, m;
    cin >> n >> m;
    n *= 2;
    m *= 2;
    ll q;
    cin >> q;
    vector<ll> bound(n + 1, m);
    for (int i = 0; i < q; ++i)
    {
        ll xx, yy;
        cin >> xx >> yy;
        xx *= 2;
        yy *= 2;
        ll x = xx, y = yy;
        ll oldbound = bound[x];
        while (x >= 0 && y <= m)
        {
            if (bound[x] == y)
                break;
            bound[x] = y;
            ++y;
            --x;
        }
        if (x < 0)
            x = 0;
        if (y > m)
            y = m;
        ll x2 = xx + 1;
        ll y2 = yy + 1;
        while (x2 <= n && y2 <= m)
        {
            if (bound[x2] == y2)
                break;
            bound[x2] = y2;
            ++y2;
            ++x2;
        }
        if (x2 > n)
            x2 = n;
        if (y2 > m)
            y2 = m;
        ld newplace = 0;
        for (int i = 0; i < x; ++i)
        {
            newplace += min(bound[i], bound[i + 1]);
            if (bound[i] != bound[i + 1])
            {
                newplace += 0.5;
            }
        }
        newplace += min(bound[xx], bound[x]) * (xx - x);
        newplace += ld(abs(bound[x] - bound[xx]) * (xx - x)) / 2;
        newplace += min(bound[xx], bound[x2]) * (x2 - xx);
        newplace += ld(abs(bound[x2] - bound[xx]) * (x2 - xx)) / 2;
        for (int i = x2; i < n; ++i)
        {
            newplace += min(bound[i], bound[i + 1]);
            if (bound[i] != bound[i + 1])
            {
                newplace += 0.5;
            }
        }
        newplace /= 2;
        newplace /= 2;
        string s = to_string(newplace);
        int ii = 0;
        bool point = false;
        for (; ii < s.size(); ++ii)
        {
            if (s[ii] == '.')
            {
                point = true;
                if (ii >= s.size() - 2)
                    s.push_back('0');
                s.resize(ii + 3);
                break;
            }
        }
        if (!point)
        {
            s.push_back('.');
            s.push_back('0');
            s.push_back('0');
        }
        cout << s << '\n';
    }
    return 0;
}