#include <iostream>
#include <vector>
#include <unordered_map>
#include <unordered_set>

using namespace std;

typedef long long ll;

vector<vector<unordered_set<int>>> cache;
vector<ll> x;
vector<ll> y;
vector<int> result_a;
vector<int> result_b;

bool recur(int a, int b, ll summ, bool st, bool ignore_mode)
{
    if (summ == 0 && !st)
    {
        return true;
    }
    if (a == 0 && b == 0)
    {
        return false;
    }
    if (cache[a][b].count(summ))
    {
        return false;
    }
    if (a == 0)
    {
        if (recur(a, b - 1, summ - y[b - 1], false, ignore_mode))
        {
            result_b.push_back(b - 1);
            return true;
        }
    }
    else if (b == 0)
    {
        if (recur(a - 1, b, summ + x[a - 1], false, ignore_mode))
        {
            result_a.push_back(a - 1);
            return true;
        }
    }
    else
    {
        if (recur(a, b - 1, summ - y[b - 1], false, ignore_mode))
        {
            result_b.push_back(b - 1);
            return true;
        }
        if (recur(a - 1, b, summ + x[a - 1], false, ignore_mode))
        {
            result_a.push_back(a - 1);
            return true;
        }
        if (!ignore_mode)
        {
            if (recur(a - 1, b - 1, summ, false, ignore_mode))
            {
                return true;
            }
        }
    }
    cache[a][b].insert(summ);
    return false;
}

int main()
{
    int n, m;
    cin >> n;
    x.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> x[i];
    cin >> m;
    y.resize(m);
    for (int i = 0; i < m; ++i)
        cin >> y[i];
    cache.resize(n, vector<unordered_set<int>>(m));
    recur(n - 1, m - 1, 0, true, true);
    if (result_a.size() == 0)
        recur(n - 1, m - 1, 0, true, false);
    cout << result_a.size() << '\n';
    for (int i = 0; i < result_a.size(); ++i)
        cout << result_a[i] << ' ';
    cout << '\n';
    cout << result_b.size() << '\n';
    for (int i = 0; i < result_b.size(); ++i)
        cout << result_b[i] << ' ';
    cout << '\n';
    return 0;
}