#include <iostream>
#include <vector>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>

using namespace std;

#pragma gcc optimize("Ofast");

typedef long long ll;

vector<vector<vector<bool>>> cache;
vector<ll> pref_a;
vector<ll> pref_b;
vector<ll> x;
vector<ll> y;
vector<int> result_a;
vector<int> result_b;
ll n, m;
ll offset = 0;

bool recur(int a, int b, ll summ, bool st, bool ignore_mode)
{
    if (summ == 0 && !st)
    {
        return true;
    }
    if (a == 0 && b == 0)
    {
        return false;
    }
    if (summ > pref_b[b] || summ < -pref_a[a])
        return false;
    if (cache[a][b][summ + offset] != false)
    {
        return false;
    }
    if (a == 0)
    {
        if (recur(a, b - 1, summ - y[b - 1], false, ignore_mode))
        {
            result_b.push_back(b - 1);
            return true;
        }
    }
    else if (b == 0)
    {
        if (recur(a - 1, b, summ + x[a - 1], false, ignore_mode))
        {
            result_a.push_back(a - 1);
            return true;
        }
    }
    else
    {
        if (recur(a, b - 1, summ - y[b - 1], false, ignore_mode))
        {
            result_b.push_back(b - 1);
            return true;
        }
        if (recur(a - 1, b, summ + x[a - 1], false, ignore_mode))
        {
            result_a.push_back(a - 1);
            return true;
        }
        if (!ignore_mode)
        {
            if (recur(a - 1, b - 1, summ, false, ignore_mode))
            {
                return true;
            }
        }
    }
    cache[a][b][summ + offset] = true;
    return false;
}

int main()
{
    cin >> n;
    x.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> x[i];
    cin >> m;
    y.resize(m);
    for (int i = 0; i < m; ++i)
        cin >> y[i];
    pref_a.resize(n + 1);
    pref_b.resize(m + 1);
    for (int i = 1; i <= n; ++i)
        pref_a[i] = pref_a[i - 1] + x[i - 1];
    for (int j = 1; j <= m; ++j)
        pref_b[j] = pref_b[j - 1] + y[j - 1];
    if (min(pref_a[n], pref_b[m]) > 10000000)
    {
        cout << 0 << '\n';
        return 0;
    }
    cache.resize(n, vector<vector<bool>>(m, vector<bool>(min(pref_a[n], pref_b[m]) * 2)));
    offset = min(pref_a[n], pref_b[m]);
    recur(n - 1, m - 1, 0, true, true);
    if (result_a.size() == 0)
    {
        cache = vector<vector<vector<bool>>>(n, vector<vector<bool>>(m, vector<bool>(min(pref_a[n], pref_b[m]) * 2)));
        recur(n - 1, m - 1, 0, true, false);
    }
    cout << result_a.size() << '\n';
    for (int i = 0; i < result_a.size(); ++i)
        cout << result_a[i] << ' ';
    cout << '\n';
    cout << result_b.size() << '\n';
    for (int i = 0; i < result_b.size(); ++i)
        cout << result_b[i] << ' ';
    cout << '\n';
    return 0;
}
