#include <bits/stdc++.h>
using namespace std;

int n, m, q, x, y;

struct square {
    double x;
    double y;
    double width;
    double height;

    square(double x, double y, double width) : x(x), y(y), width(width), height(width) {}
    square(double x, double y, double width, double height) : x(x), y(y), width(width), height(height) {}

    double getS() { return this->getWidth() * this->getHeight(); }
    double getActualS() { return this->getS() / 2; }
    double getX() { return this->x; }
    double getY() { return this->y; }
    double getWidth() { return this->width; }
    double getHeight() { return this->height; }
    bool isCollide(square sqr) { return this->getX() > sqr.getX() - sqr.getWidth() &&
                                        this->getX() - this->getWidth() < sqr.getX() &&
                                        this->getY() > sqr.getY() - sqr.getHeight() &&
                                        this->getY() - this->getHeight() < sqr.getY(); }
    square getCollision(square sqr) { return square(min(this->getX(), sqr.getX()),
                                                    min(this->getY(), sqr.getY()),
                                                    min(this->getX(), sqr.getX()) -
                                                    max(this->getX() - this->getWidth(), sqr.getX() - sqr.getWidth()),
                                                    min(this->getY(), sqr.getY()) -
                                                    max(this->getY() - this->getHeight(), sqr.getY() - sqr.getHeight())); }

    void out() { cout << "square(" << this->getX() << ", " << this->getY() << " : " << this->getWidth() << ", " << this->getHeight() << ")" << endl; }
};

struct world {
    double n, m, s;
    vector<square> squares;

    world(double n, double m) : n(n), m(m), s(0) {}

    void add(double x, double y) {
        const double c = 0.7071067811865;
        double width = (m - y) / c;
        pair<double, double> nc = this->convertToQuadratic(x, y);
        x = nc.first;
        y = nc.second;
        this->squares.push_back(square(x, y, width));
        this->calcS();
    }

    void calcS() {
        this->s = n * m;
        for (int i = 0; i < squares.size(); i++) {
            this->s -= this->squares[i].getActualS();
            for (int j = i + 1; j < squares.size(); j++) {
                if (this->squares[i].isCollide(this->squares[j])) {
                    this->s += this->squares[i].getCollision(this->squares[j]).getActualS();
                }
            }
        }
    }

    double getS() { return this->s; }

    pair<double, double> convertToQuadratic(double x, double y) {
        const double c = 0.7071067811865;
        return make_pair(-(x + y) * c, -(x - y) * c);
    }
};

int main() {
    cin >> n >> m >> q;
    world wrld = world(n, m);
    for (int i = 0; i < q; i++) {
        cin >> x >> y;
        wrld.add(x, y);
        cout << fixed << setprecision(2) << wrld.getS() << endl;
    }
}
