#include <iostream>
#include <iomanip>
#include <set>
#include <tuple>
#include <algorithm>
#define int long long

using namespace std;
int n, m, q;
double arie;
int countsegm=2;
struct segment {
    int st, dr, hst, hdr, slope;
    segment() {}
    segment(int s, int d, int l, int r, int se) : st(s), dr(d), hst(l), hdr(r), slope(se) {}
    bool operator < (const segment &rhs) const {
        return tie(st, dr, hst, hdr, slope) < tie(rhs.st, rhs.dr, rhs.hst, rhs.hdr, rhs.slope);
    }
    int evalueaza(int poz) {
        return hst + (poz-st) * slope;
    }
};
multiset<segment> Tabla;

pair<segment, segment> sparge(segment orig, int poz) {
    segment a, b;
    a = b = orig;
    a.dr = poz;
    a.hdr = a.hst + a.slope * (a.dr - a.st);

    b.st = poz;
    b.hst = b.hdr - b.slope * (b.dr - b.st);
    return make_pair(a, b);
}

int intersectie(segment a, segment b) {
    if(a.slope < b.slope) swap(a, b);
    return (a.st + b.st + b.hst - a.hst) / 2;
}

void adauga(segment linie) { ///vom adauga linie la Tabla(cu operatile necesare)
    //cautam binar prima intersectie
    auto itst = lower_bound(Tabla.begin(), Tabla.end(), linie, [](auto a, auto b) {
            return a.dr < b.st; }); /// b=linie
    ///itst -> primul segment care are capatul de dreapta in linie (il spargem pentru comfort)
    if(1) {
        auto [j1, j2] = sparge(*itst, linie.st);
        Tabla.erase(itst);
        if(j1.st != j1.dr) Tabla.insert(j1);
        if(j2.st != j2.dr) Tabla.insert(j2);
        itst = Tabla.lower_bound(j2);
    }
    //cautam binar a doua intersectie
    auto itdr = lower_bound(Tabla.begin(), Tabla.end(), linie, [](auto a, auto b){
            return a.st < b.dr;
    });
    if(itdr != Tabla.begin()){
        --itdr;///ultimul segment cu stanga inca in linie
        auto [j1, j2] = sparge(*itdr, linie.dr);
        Tabla.erase(itdr);
        if(j1.st != j1.dr) Tabla.insert(j1);
        if(j2.st != j2.dr) Tabla.insert(j2);
        itdr = Tabla.find(j2);
    }
    segment vechi, nou;
    int sterge = 0, adauga = 0;
    while(itst != itdr && itst -> st < linie.dr) {
        vechi = nou = *itst;
        --itst;
        sterge = 1;
        adauga = 1;
        ///vom modifica itst pentru a se conforma cu linie
        if(nou.slope == 0) {
            ///e linie de baza, va mosteni pur si simplu linia noastra
            arie -= (nou.hdr + nou.hst) * (nou.dr - nou.st) / 2.0;
            nou.hst = linie.evalueaza(nou.st);
            nou.hdr = linie.evalueaza(nou.dr);
            nou.slope = linie.slope;
            arie += (nou.hdr + nou.hst) * (nou.dr - nou.st) / 2.0;
        } else if(nou.slope == linie.slope) {
            ///sunt paralele, vedem care e mai sus si o tinem minte
            if(nou.hst > linie.evalueaza(nou.st)) {
                arie -= (nou.hdr + nou.hst) * (nou.dr - nou.st) / 2.0;
                nou.hst = linie.evalueaza(nou.st);
                nou.hdr = linie.evalueaza(nou.dr);
                nou.slope = linie.slope;
                arie += (nou.hdr + nou.hst) * (nou.dr - nou.st) / 2.0;
            } else {
                sterge = 0;
                adauga = 0;
            }
        } else {
            ///sunt la un unghi de 90 de grade :( Trebuie sa vedem daca un o depaseste vehement pe cealalta
            ///altfel trebuie sa stergem st si sa adaugam segmentele (st, intersectie) si (intersectie, dr)
            if(((nou.hst <= linie.evalueaza(nou.st)) == (nou.hdr <= linie.evalueaza(nou.dr))) ||
               ((nou.hst == linie.evalueaza(nou.st)) || (nou.hdr == linie.evalueaza(nou.dr)))) {
                //una este superioara celeilalte
                if((nou.hst > linie.evalueaza(nou.st)) || (nou.hdr > linie.evalueaza(nou.dr))) {
                    arie -= (nou.hdr + nou.hst) * (nou.dr - nou.st) / 2.0;
                    nou.hst = linie.evalueaza(nou.st);
                    nou.hdr = linie.evalueaza(nou.dr);
                    nou.slope = linie.slope;
                    arie += (nou.hdr + nou.hst) * (nou.dr - nou.st) / 2.0;
                } else {
                    sterge = 0;
                    adauga = 0;
                }
            } else {
                int poz = intersectie(nou, linie);
                auto [j1, j2] = sparge(nou, poz);
                if(j1.st != j1.dr) Tabla.insert(j1);
                if(j2.st != j2.dr) Tabla.insert(j2);
                adauga = 0;
                sterge = 1;
            }
        }
        if(sterge)
            Tabla.erase(Tabla.find(vechi));
        if(nou.st == nou.dr) adauga = 0;
        if(adauga)
            Tabla.insert(nou);
        ++itst;
        if(itst == Tabla.end())break;
        if(sterge == adauga) ++itst;
        if(itst == Tabla.end())break;
    }
}

void taie(int p, int q) {
    segment latura;
    ///partea stanga a taieturii
    latura.slope = -1;
    latura.st = max(p - (m - q), 0);
    latura.dr = p;
    latura.hdr = q;
    latura.hst = latura.hdr - latura.slope * (latura.dr - latura.st);
    if(latura.st != latura.dr) adauga(latura);

    ///partea dreapta a taieturii
    latura.slope = 1;
    latura.st = p;
    latura.hst = q;
    latura.dr = min(p + (m - q), n);
    latura.hdr = latura.hst + latura.slope * (latura.dr - latura.st);
    if(latura.st != latura.dr) adauga(latura);
}

signed main() {
//    freopen("a.in", "r", stdin);
    cin >> n >> m >> q;
    n *= 2;
    m *= 2;
    arie = n * m;
    Tabla.insert({-1, -1, m, m, 0});
    Tabla.insert({0, n, m, m, 0});
    int x, y;
    for(int i = 1; i <= q; ++i) {
        cin >> x >> y;
        taie(2 * x, 2 * y);
        cout << fixed << setprecision(2) << (arie / 4.) << "\n";
    }
    return 0;
}
