#include<bits/stdc++.h>
typedef long long ll;

using namespace std;

template<typename T>
bool assign_max(T& a, T b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

struct node {
	ll l, r;
	double m1, m2, sum, le, fe;
	node *nl = nullptr, *nr = nullptr;
	node(ll l, ll r): l(l), r(r) {
		m1 = -1;
		le = 0;
		fe = 0;
	}
	node *get_l() {
		if (nl == nullptr) {
			nl = new node(l, (l + r) / 2);
		}
		return nl;
	}
	node *get_r() {
		if (nr == nullptr) {
			nr = new node((l + r) / 2, r);
		}
		return nr;
	}
	void add_m(double mn1, double mn2) {
		m1 = mn1;
		m2 = mn2;
		sum = m1*(r - l) + m2*((r - l - 1) * (r - l) / 2);
		le = m1 + m2 * (r - l - 1);
		fe = m1;
	}
	void push() {
		if (m1 == -1) {
			return;
		}
		ll mid = (l + r) / 2;
		get_l()->add_m(m1, m2);
		get_r()->add_m(m1 + (mid - l) * m2, m2);
		m1 = -1;
	}
	ll change(ll ql, ll qr, double mm1, double mm2) {
		if (ql <= l && r <= qr) {
			add_m(mm1, mm2);
			return r - l;
		}
		if (qr <= l || r <= ql) {
			return 0;
		}
		push();
		ll mid = (l + r) / 2;
		ll cl = get_l()->change(ql, qr, mm1, mm2);
		cl += get_r()->change(ql, qr, mm1 + cl * mm2, mm2);
		sum = get_l()->sum + get_r()->sum;
		le = get_r()->le;
		fe = get_l()->fe;
		return cl;
	}
	double get(ll x) {
		if (x < l || r <= x) {
			return 0;
		}
		if (r - l == 1) {
			return sum;
		}
		push();
		ll mid = (l + r) / 2;
		return get_l()->get(x) + get_r()->get(x);
	}
	ll go_down_first(double f0, double fu, ll ql) {
		if (r - l == 1) {
			return l;
		}
		ll mid = (l + r) / 2;
		if ((mid >= ql) || (get_l()->le < (f0 + fu*(mid - 1)))) {
			return get_l()->go_down_first(f0, fu, ql);
		} else {
			return get_r()->go_down_first(f0, fu, ql);
		}
	}
};

struct segment_tree {
	node *root = nullptr;
	segment_tree(ll n) {
		root = new node(0, n);
	}
	double get() {
		return root->sum;
	}
	double get(ll x) {
		return root->get(x);
	}
	void change(ll ql, ll qr, double mm1, double mm2) {
		root->change(ql, qr, mm1, mm2);
	}
	ll go_down_first(double f0, double fu, ll ql) {
		return root->go_down_first(f0, fu, ql);
	}
};

vector<string> solve(ll n, ll m, ll q, vector<pair<ll, ll>> qs) {
	vector<string> a;
	segment_tree st(n * 2);
	for (auto[x, y] : qs) {
		y = m - y;
		ll l = -1, r = st.go_down_first(y - abs(0.25 - x), 0.5, x*2);
		//while (r - l > 1) {
		//	ll mid = (l + r) / 2;
		//	if (st.get(mid) < (y - abs((mid / 2 + ((double)(mid % 2)) / 2 + 0.25) - x))) {
		//		r = mid;
		//	} else {
		//		l = mid;
		//	}
		//}
		if (st.get(r) < (y - abs((r / 2 + ((double)(r % 2)) / 2 + 0.25) - x))) {
			st.change(r, x * 2, (y - abs((r / 2 + ((double)(r % 2)) / 2 + 0.25) - x)), 0.5);
		}
		l = x * 2;
		r = n * 2;
		while (r - l > 1) {
			ll mid = (l + r) / 2;
			if (st.get(mid) < (y - abs((mid / 2 + ((double)(mid % 2)) / 2 + 0.25) - x))) {
				l = mid;
			} else {
				r = mid;
			}
		}
		if (st.get(l) < (y - abs((l / 2 + ((double)(l % 2)) / 2 + 0.25) - x))) {
			st.change(x * 2, r, y - 0.25, -0.5);
		}
		double ans = n * m - st.get() / 2;
		a.push_back(to_string((ll)(ans)) + "." + to_string(((ll)(ans * 10)) % 10) + to_string(((ll)(ans * 100)) % 10));
	}
	return a;
}

vector<string> solve2(ll n, ll m, ll q, vector<pair<ll, ll>> qs) {
	vector<string> a;
	segment_tree st(n * 2);
    	vector<double> arr(n * 2, 0);
	double ans = n * m;
	for (auto[x, y] : qs) {
		y = m - y;
		for (ll j = 0; j < n * 2; j++) {
	            ans += arr[j] / 2;
        	    assign_max(arr[j], (y - abs((j / 2 + ((double)(j % 2)) / 2 + 0.25) - x)));
		    ans -= arr[j] / 2;
       		}
		a.push_back(to_string((ll)(ans)) + "." + to_string(((ll)(ans * 10)) % 10) + to_string(((ll)(ans * 100)) % 10));
	}
	return a;
}

mt19937 rnd(time(0));

tuple<ll, ll, ll, vector<pair<ll, ll>>> gen() {
	ll n = rnd() % 10 + 1, m = rnd() % 10 + 1, q = rnd() % 10 + 1;
	vector<pair<ll, ll>> qs(q);
	for (ll i = 0; i < q; i++) {
		qs[i].first = rnd() % n;
		qs[i].second = rnd() % m;
	}
	return {n, m, q, qs};
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	bool iss = false;
	ll n, m, q;
	vector<pair<ll, ll>> qs;
	if (!iss) {
		cin >> n >> m >> q;
		qs.resize(q);
		for (ll i = 0; i < q; i++) {
			cin >> qs[i].first >> qs[i].second;
		}
	}
	if (iss) {
		while (true) {
			auto[n, m, q, qs] = gen();
			if (solve(n, m, q, qs) != solve2(n, m, q, qs)) {
				cout << n << ' ' << m << ' ' << q << '\n';
				for (auto i : qs) {
					cout << i.first << ' ' << i.second << '\n';
				}
				return 0;
			}
		}
	}
	if (!iss) {
		for (auto i : solve(n, m, q, qs)) {
			cout << i << '\n';
		}
	}
}
