#include <bits/stdc++.h>

using namespace std;

//mt19937 rnd(228);

#define ll long long
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()
#define ld long long
#define int ll
#define trace(x) cout << #x << " = " << x << endl;

const int infI = 1e9 + 7;
const ll infL = 1e18;
const int maxN = 500000;

int inter(int a, int b, int c, int d) {
    return max(0ll, min(b, d) - max(a, c));
}

struct segtree {
    ll L = 0, R;

    struct node {
        ll sum = 0;
        ll y = 0, sz = 0;
        ll x = -infL;
        int l = -1, r = -1;
    };

    ll get(ll sz, ll x, ll y) {
        return x * sz + sz * (sz - 1) / 2 * y;
    }


    vector<node> t;

    void init(ll r) {
        R = r;
        t = {{}};
        t[0].sz = R;
    }

    void upd(int x) {
        t[x].sum = get(t[x].sz, t[x].x, t[x].y);
    }

    void push(int x) {
        if (t[x].l == -1) {
            t[x].l = sz(t);
            t.emplace_back();
            t[t[x].l].sz = t[x].sz / 2;
        }
        if (t[x].r == -1) {
            t[x].r = sz(t);
            t.emplace_back();
            t[t[x].r].sz = t[x].sz - t[t[x].l].sz;
        }
        if (t[x].x == -infL) return;
        int l = t[x].l, r = t[x].r;
        t[l].x = t[x].x, t[l].y = t[x].y;
        t[r].x = t[x].x + t[x].y * t[l].sz;
        t[r].y = t[x].y;
        upd(l), upd(r);
        t[x].x = -infL;
        t[x].y = 0;
    }

    ld getSum() {
        return t[0].sum;
    }

    ld get(ll i, int x, ll lx, ll rx) {
        if (lx + 1 == rx) return t[x].sum;
        ll m = (lx + rx) >> 1;
        push(x);
        if (m > i) {
            return get(i, t[x].l, lx, m);
        } else {
            return get(i, t[x].r, m, rx);
        }
    }

    ld get(int i) {
        return get(i, 0, 0, R);
    }

    void st(ll l, ll r, ld X, ll Y) {
        if (l >= r) return;
//        trace(X)
//        trace(Y)
        st(l, r, X, Y, 0, 0, R);
    }

    void st(ll l, ll r, ld X, ll Y, int x, ll lx, ll rx) {
        if (l >= rx || lx >= r) return;
        if (l <= lx && rx <= r) {
            t[x].x = X, t[x].y = Y;
            upd(x);
//            trace(t[x].sum)
            return;
        }
        push(x);
        ll m = (lx + rx) >> 1;
        st(l, r, X, Y, t[x].l, lx, m);
        X += inter(l, r, lx, m) * Y;
        st(l, r, X, Y, t[x].r, m, rx);
        t[x].sum = t[t[x].l].sum + t[t[x].r].sum;
    }

};


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll n, m;
    cin >> n >> m;
    int q;
    cin >> q;
    n *= 4, m *= 4;
    segtree t;
    t.init(n);
    ld all = n * m;
    while (q--) {
        ll x, y;
        cin >> x >> y;
        x *= 4, y *= 4;
//        trace(x)
        y = m - y;
        ll l = x - 1, r = n;
        ld s = (ld) y * 2 - 1;
//        trace(x)
//        trace(s)
//        trace(t.get(n - 1))
        while (l + 1 < r) {
            ll mid = (l + r) >> 1;
            if (t.get(mid) >= s - (mid - x) * 2) r = mid;
            else l = mid;
        }
//        trace(r);
        t.st(x, r, s, -2);
        r = x;
        l = -1;
//        trace(t.get(0))
//        trace(s - x)
        while (l + 1 < r) {
            ll mid = (l + r) >> 1;
            if (t.get(mid) > s - (x - mid - 1) * 2) l = mid;
            else r = mid;
        }
//        trace(l)
//        trace(s - (x - l) + 1)
        t.st(l + 1, x, s - ((x - r - 1)) * 2, 2);
//        trace(t.getSum())
        cout << setprecision(2) << fixed << (all - t.getSum() * 0.5) * 1.0 / 16  << '\n';
    }
    return 0;
}