#include <iostream>
#include <iomanip>
#include <map>
#include <vector>

void outF(double n)
{ std::cout << std::setprecision(2) << std::fixed << n << std::endl; }

double makeCut(int width, int height, int x, int y)
{
	static std::map<std::pair<int, int>, int> cuts;
	static double area = (double)width * height;

	double areaCut = 0;
	std::vector<std::pair<int, int>> layers(height - y);
	// Wings
	for (int i = 0; i < height - y; i++) {
		if (x - i - 1 >= 0) {
			if (cuts[{x - i - 1, y + i}] == 0)
				cuts[{x - i - 1, y + i}] = 2;
			else if (cuts[{x - i - 1, y + i}] == 2)
				cuts[{x - i - 1, y + i}] = 3;
		}
		if (x + i < width) {
			if (cuts[{x + i, y + i}] == 0)
				cuts[{x + i, y + i}] = 2;
			else if (cuts[{x + i, y + i}] == 2)
				cuts[{x + i, y + i}] = 3;
		}

		layers[i].first = std::max(x - i - 1, 0);
		layers[i].second = std::min(x + i, width - 1);
	}

	// Area in between
	for (int i = y; i < height; i++)
		for (int j = layers[i - y].first; j <= layers[i - y].second; j++) {
			areaCut += (4.0 - cuts[{j, i}]) / 4;
			if (cuts[{j, i}] != 4) {
				if (j == layers[i - y].first || j == layers[i - y].second)
					cuts[{j, i}] = (4 - cuts[{j, i}]); // <- bad
				else cuts[{j, i}] = 4;
			}
		}
	return area -= areaCut;
}

int main()
{
	int N, M, Q;
	std::cin >> N >> M >> Q;
	std::vector<std::pair<int, int>> inputs(Q);
	for (int i = 0; i < Q; i++)
		std::cin >> inputs[i].first >> inputs[i].second;
	
	double previousArea = (double)N * M;
	for (auto p : inputs)
		outF(makeCut(N, M, p.first, p.second));
	
	return 0;
}