#define _CRT_SECURE_NO_WARNINGS

/*--------------Define--------------*/
#define MOD 1000000007
#define INF 1000000000
#define cn const
#define pb push_back
#define ppb pop_back
#define ff first
#define ss second
#define sz size()
#define all(x) x.begin(), x.end()
#define sortall(x) sort(all(x))


/*--------------Include--------------*/
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <queue>
#include <string>
#include <fstream>
#include <ostream>
#include <deque>
#include <iomanip>
#include <map>
#include <set>
#include <stack>
#include <cstdlib>

#define endl '\n'


using namespace std;


using ll = long long;
using ull = unsigned long long;
using pll = pair<long long, long long>;
using vl = vector<long long>;
using vpll = vector<pair<long long, long long>>;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using vs = vector<string>;
using vpii = vector<pii>;


template<typename T>
constexpr T sqr(const T& x)
{
    return x * x;
}

template<typename T>
bool rMin(T& v, const T& rval)
{
    if (rval < v) {
        v = rval;
        return true;
    }
    return false;
}

template<typename T>
bool rMax(T& v, const T& rval)
{
    if (v < rval) {
        v = rval;
        return true;
    }
    return false;
}


bool b1[1000003];
bool b2[1000003];

int Lower_bound(const vpll& a, ll x)
{
    int l = -1;
    int r = a.sz - 1;

    while (r - l > 1)
    {
        int mid = (l + r) / 2;

        if (a[mid].ff < x)
        {
            l = mid;
        }
        else
        {
            r = mid;
        }
    }

    return r;
}

void solve()
{
    int n;

    cin >> n;

    vpll a(n);

    for (int i = 0; i < n; i++)
    {
        cin >> a[i].ff;
        a[i].ss = i;
    }

    int m;

    cin >> m;

    vpll b(m);

    for (int i = 0; i < m; i++)
    {
        cin >> b[i].ff;
        b[i].ss = i;
    }

    sortall(a);
    sortall(b);

    for (int i = 0; i < n; i++)
    {
        int l = -1;
        int r = m - 1;

        while (r - l > 1)
        {
            int mid = (l + r) / 2;

            if (b[mid] < a[i])
            {
                l = mid;
            }
            else
            {
                r = mid;
            }
        }

        if (b[r] == a[i])
        {
            cout << 1 << endl << i << endl << 1 << endl << r << endl;
            return;
        }
    }
    
    ll sum1 = a[0].ff;
    ll sum2 = b[0].ff;

    b1[a[0].ss] = b2[b[0].ss] = true;

    while (sum1 != sum2)
    {
        ll r = max(sum1, sum2) - min(sum1, sum2);

        if (sum1 < sum2)
        {
            auto x = Lower_bound(a, r);

            for (int j = x; j < n; j++)
            {
                if (!b1[a[j].ss])
                {
                    sum1 += a[j].ff;
                    b1[a[j].ss] = true;
                    break;
                }
            }
        }
        else if (sum1 > sum2)
        {
            auto x = Lower_bound(b, r);

            for (int j = x; j < m; j++)
            {
                if (!b2[b[j].ss])
                {
                    sum2 += b[j].ff;
                    b2[b[j].ss] = true;
                    break;
                }
            }
        }
    }

    vi res1, res2;
    for (int j = 0; j < n; j++)
    {
        if (b1[j])
        {
            res1.pb(j);
        }
    }
    for (int j = 0; j < m; j++)
    {
        if (b2[j])
        {
            res2.pb(j);
        }
    }

    cout << res1.sz << endl;
    for (int j = 0; j < res1.sz; j++)
    {
        cout << res1[j] << ' ';
    }
    cout << endl << res2.sz << endl;
    for (int j = 0; j < res2.sz; j++)
    {
        cout << res2[j] << ' ';
    }
    cout << endl;

    return;
}



int main()
{
#ifdef _DEBUG
    freopen("Input.txt", "r", stdin);
#endif // _DEBUG


    ios::sync_with_stdio(false);
    cin.tie(0);


    int t = 1;
    //cin >> t;

    while (t--)
    {
        solve();
    }



#ifdef _DEBUG
    cin.get();
#endif // _DEBUG

    return 0;
}