#include<bits/stdc++.h>
using namespace std;

long long n,m;
int q,len;
long double x,y,l,r,tt;
long double sum,ans,minp,lastp,lasth;

struct node{
    long double pos,h;
    int kind;
    long long y;
    node *l,*r;
    node (long double pos,long double h,int kind,long long y){
        this->pos=pos;
        this->kind=kind;
        this->h=h;
        this->y=y;
        this->l=this->r=NULL;
    }
};

node *treap;

void split(node *curr,node* &l,node* &r,long double val){
    if(curr==NULL){
        l=NULL;
        r=NULL;
        return;
    }

    if(curr->pos<=val){
        l=curr;
        split(curr->r,l->r,r,val);
    }else{
        r=curr;
        split(curr->l,l,r->l,val);
    }
}


void mergev(node* &curr,node *l,node *r){
    if(l==NULL){
        curr=r;
        return;
    }
    if(r==NULL){
        curr=l;
        return;
    }

    if(l->y>r->y){
        curr=l;
        mergev(curr->r,l->r,r);
    }else{
        curr=r;
        mergev(curr->l,l,r->l);
    }
}

void insertv(long double pos,long double h,int kind){
    node *l,*r;
    split(treap,l,r,pos-0.01);
    node *tt=new node(pos,h,kind,rand()%92364892);
    mergev(treap,l,tt);
    mergev(treap,treap,r);
}

void erasev(long double from,long double to){
    node *l,*r,*lt,*rt;
    split(treap,l,r,from-0.01);
    split(r,lt,rt,to);
    mergev(treap,l,rt);
}

long double calc(long double pt,long double h,int kind,long double pos){
    if(kind==0){
        return h-(pt-pos);
    }else{
        return h+(pt-pos);
    }
}

long double getval(node *curr,long double pos){
    if(pos<0.0 or pos>m)return m;
    if(curr==NULL)return 0.0;
    if(curr->l!=NULL and curr->l->pos>=pos){
        return getval(curr->l,pos);
    }else if(curr->pos>=pos){
        return calc(curr->pos,curr->h,curr->kind,pos);
    }else{
        return getval(curr->r,pos);
    }
}

long double zero;

long double getvall(node *curr,long double pos){
    return max(zero,getval(curr,pos));
}

void prnt(node *curr){
    if(curr->l!=NULL){
        prnt(curr->l);
    }
    if(curr->r!=NULL){
        prnt(curr->r);
    }
}

void calcsum(node *curr){
    if(curr->l!=NULL){
        calcsum(curr->l);
    }

    sum+=(lasth+curr->h)/2.0*(curr->pos-lastp);
    lasth=curr->h;
    lastp=curr->pos;

    if(curr->r!=NULL){
        calcsum(curr->r);
    }
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>m>>n>>q;
    minp=m;
    for(int i=1;i<=q;i++){
        cin>>x>>y;
        y=n-y;
        minp=min(minp,max(x-y,zero));

        l=-1.0;r=x;
        while(l+0.0001<r){
            tt=(l+r)/2.0;
            if(getvall(treap,tt)<=calc(x,y,0,tt)){
                r=tt;
            }else{
                l=tt;
            }
        }
        if(getvall(treap,r)!=0.0){
            erasev(r,x);
            insertv(r,calc(x,y,0,r),1);
        }else{
            erasev(r+0.01,x);
        }
        
        l=x;r=m+1.0;
        while(l+0.0001<r){
            tt=(l+r)/2.0;
            if(getvall(treap,tt)<=calc(x,y,1,tt)){
                l=tt;
            }else{
                r=tt;
            }
        }
        erasev(x,l);
        insertv(l,calc(x,y,1,l),1);

        insertv(x,y,0);

        sum=0;
        lastp=minp;
        lasth=0.0;
        calcsum(treap);
        ans=n*m-sum;
        cout<<setprecision(2)<<fixed<<ans<<"\n";
    }

    return 0;
}