#include <iostream>
#include <algorithm>
#include <stack>
using namespace std;
const int maxn = 5e5+10, maxm = 15e5+10;

string res;
int last1[maxn];
int last2[maxn];
struct edge {

    int pr, to, ix;
    edge(){}
    edge(int from, int _to, int _ix, bool which) {

        if (!which) {
            pr = last1[from];
            last1[from] = _ix;
        } else {
            pr = last2[from];
            last2[from] = _ix;
        }

        ix = _ix;
        to = _to;

    }

} v[maxm], rev[maxm];

stack < int > topsort;
int in_scc[maxn], first_scc[maxn], cnt;
int bl[maxn];
int n, m;

void dfs_topsort(int x) {

    // cout << "dfs: " << x << '\n';

    bl[x] = 1;
    for (int edge_ix = last1[x] ; edge_ix != -1 ; edge_ix = v[edge_ix].pr) {

        // cout << x << " neigh: " << v[edge_ix].to << ' ' << bl[v[edge_ix].to] << '\n'; 

        if (bl[v[edge_ix].to]) continue;
        dfs_topsort(v[edge_ix].to);

    }

    topsort.push(x);

}

void dfs_scc(int x) {

    bl[x] = 1;
    in_scc[x] = cnt;
    for (int edge_ix = last2[x] ; edge_ix != -1 ; edge_ix = rev[edge_ix].pr) {

        if (bl[rev[edge_ix].to]) continue;
        dfs_scc(rev[edge_ix].to);

    }

}

void dfs_edges(int x, int currscc) {

    bl[x] = 1;
    // cout << "curr: " << x << ' ' << currscc << '\n';

    for (int edge_ix = last1[x] ; edge_ix != -1 ; edge_ix = v[edge_ix].pr) {

        // cout << x << " neighboor: " << to << ' ' << ix << ' ' << bl[to] << '\n'; 

        if (in_scc[v[edge_ix].to] != currscc || bl[v[edge_ix].to] == 2) continue;
        if (bl[v[edge_ix].to] == 1) {

            res[v[edge_ix].ix] = '1';
            continue;

        }

        dfs_edges(v[edge_ix].to, currscc);

    } 

    bl[x] = 2;

    // cout << "done: " << x << '\n';

}

string find_reverse(int N, int M, int connections[][2]) {

    fill(last1+1, last1+N+1, -1);
    fill(last2+1, last2+N+1, -1);

    n = N;
    m = M;
    for (int i = 0 ; i < m ; ++i) v[i] = edge(connections[i][0], connections[i][1], i, 0);
    for (int i = 0 ; i < m ; ++i) rev[i] = edge(connections[i][1], connections[i][0], i, 1);

    for (int i = 1 ; i <= n ; ++i) {

        if (bl[i]) continue;
        dfs_topsort(i);

    }

    // cerr << "topsort:\n";

    fill(bl+1, bl+1+n, 0);
    int top;

    while (!topsort.empty()) {

        top = topsort.top();
        topsort.pop();
        // cerr << top << ' ';
        if (bl[top]) continue;
        ++cnt;
        first_scc[cnt] = top;
        dfs_scc(top);

    }

    // cerr << '\n';

    // cerr << "scc:\n";
    // for (int i = 1 ; i <= cnt ; ++i) {

    //     cerr << i << ":";
    //     for (int j : scc[i])
    //         cerr << ' ' << j;
    //     cerr << '\n';

    // }

    fill(bl+1, bl+1+n, 0);
    res.resize(m, '0');

    for (int i = 1 ; i <= cnt ; ++i) 
        dfs_edges(first_scc[i], i);

    // cerr << "end graph:\n";
    // for (int i = 0 ; i < m ; ++i) {

    //     if (res[i] == '0') cout << connections[i][0] << ' ' << connections[i][1] << '\n';
    //     else cout << connections[i][1] << ' ' << connections[i][0] << '\n';

    // }

    return res;

}
