#include <iostream>
#include <algorithm>
#include <stack>
#include <queue>
using namespace std;
const int maxn = 5e5+10, maxm = 15e5+10;

string res;
int last1[maxn];
int last2[maxn];
int all_edges[maxn];
queue < int > q;

struct edge {

    int pr, to;
    edge(){}
    edge(int from, int _to, int ix, int which) {

        if (which == 0) {
            pr = last1[from];
            last1[from] = ix;
        } else if (which == 1) {
            pr = last2[from];
            last2[from] = ix;
        } else {
            pr = all_edges[from];
            all_edges[from] = ix;
        }

        to = _to;

    }

} v[maxm], rev[maxm], all[2*maxm];

stack < int > topsort;
int in_scc[maxn], first_scc[maxn], cnt;
int bl[maxn];
int n, m;

void dfs_topsort(int x) {

    // cout << "dfs: " << x << '\n';

    bl[x] = 1;
    for (int edge_ix = last1[x] ; edge_ix != -1 ; edge_ix = v[edge_ix].pr) {

        // cout << x << " neigh: " << v[edge_ix].to << ' ' << bl[v[edge_ix].to] << '\n'; 

        if (bl[v[edge_ix].to]) continue;
        dfs_topsort(v[edge_ix].to);

    }

    topsort.push(x);

}

void dfs_scc(int x) {

    bl[x] = 1;
    in_scc[x] = cnt;
    for (int edge_ix = last2[x] ; edge_ix != -1 ; edge_ix = rev[edge_ix].pr) {

        if (bl[rev[edge_ix].to]) continue;
        dfs_scc(rev[edge_ix].to);

    }

}

int dist[maxn];
void bfs_edges(int currscc) {

    q.push(first_scc[currscc]);
    dist[first_scc[currscc]] = 1;

    while (!q.empty()) {

        int top = q.front();
        q.pop();

        // cout << "curr: " << top << '\n';
        
        for (int edge_ix = all_edges[top] ; edge_ix != -1 ; edge_ix = all[edge_ix].pr) {

            // cout << "edge_ix: " << edge_ix << ' ' << all[edge_ix].to << '\n';

            if (dist[all[edge_ix].to] || currscc != in_scc[all[edge_ix].to]) continue;
            dist[all[edge_ix].to] = dist[top]+1;
            q.push(dist[all[edge_ix].to]);

        }

    }

}

string find_reverse(int N, int M, int connections[][2]) {

    fill(last1+1, last1+N+1, -1);
    fill(last2+1, last2+N+1, -1);
    fill(all_edges+1, all_edges+N+1, -1);

    n = N;
    m = M;
    for (int i = 0 ; i < m ; ++i) {
        
        v[i] = edge(connections[i][0], connections[i][1], i, 0);
        all[i] = edge(connections[i][0], connections[i][1], i, 2);

    }

    for (int i = 0 ; i < m ; ++i) {
        
        rev[i] = edge(connections[i][1], connections[i][0], i, 1);
        all[m+i] = edge(connections[i][1], connections[i][0], m+i, 2);

    }

    for (int i = 1 ; i <= n ; ++i) {

        if (bl[i]) continue;
        dfs_topsort(i);

    }

    // cerr << "topsort:\n";

    fill(bl+1, bl+1+n, 0);
    int top;

    while (!topsort.empty()) {

        top = topsort.top();
        topsort.pop();
        // cerr << top << ' ';
        if (bl[top]) continue;
        ++cnt;
        first_scc[cnt] = top;
        dfs_scc(top);

    }

    // cerr << '\n';

    // cerr << "scc " << cnt << "\n";
    // for (int i = 1 ; i <= cnt ; ++i) {

    //     cerr << i << ":";
    //     for (int j : scc[i])
    //         cerr << ' ' << j;
    //     cerr << '\n';

    // }

    for (int i = 1 ; i <= cnt ; ++i) 
        bfs_edges(i);

    cout << "dists: \n";
    for (int i = 1 ; i <= n ; ++i)
        cout << i << " = " << dist[i] << '\n';

    res.resize(m, '0');
    for (int i = 0 ; i < m ; ++i) {

        if (in_scc[connections[i][0]] != in_scc[connections[i][1]]) continue;
        if (dist[connections[i][1]] > dist[connections[i][0]]) res[i] = '1';

    }

    cerr << "end graph:\n";
    for (int i = 0 ; i < m ; ++i) {

        if (res[i] == '0') cout << connections[i][0] << ' ' << connections[i][1] << '\n';
        else cout << connections[i][1] << ' ' << connections[i][0] << '\n';

    }

    return res;

}
