#include <iostream>
#include <algorithm>
#include <cassert>
#include <queue>
using namespace std;
const int maxn = 5e5+10, maxm = 15e5+10;

int last[maxn], last2[maxn];
int oriented[maxm];
int conn[maxm][2];
int in[maxn], timer, tree_cnt;
int n, m;

struct edge {

    int pr, to, ix;
    edge(){}
    edge(int from, int _to, int _ix, bool which) {

        if (which == 0) {
            pr = last[from];
            last[from] = _ix;
        } else {
            pr = last2[from];
            last2[from] = _ix;
        }
        if (_ix >= m) ix = _ix-m;
        else ix = _ix;
        to = _to;

    }

} v[2*maxm], tree[maxm];

queue < int > q;
int dist[maxn];

void bfs_edges(int start) {

    q.push(start);
    dist[start] = 1;

    while (!q.empty()) {

        int top = q.front();
        q.pop();

        // cout << "curr: " << top << '\n';
        
        for (int edge_ix = last[top] ; edge_ix != -1 ; edge_ix = v[edge_ix].pr) {

            // cout << "edge_ix: " << edge_ix << ' ' << v[edge_ix].to << ' ' << v[edge_ix].ix << ' ' << dist[v[edge_ix].to] << ' ' << dist[top] << '\n';

            if (dist[v[edge_ix].to]) continue;
            dist[v[edge_ix].to] = dist[top]+1;

            if (conn[v[edge_ix].ix][0] == top) oriented[v[edge_ix].ix] = 1;
            else oriented[v[edge_ix].ix] = 2;

            // cout << "here\n";
            // cout << "   tree edge: " << top << ' ' << v[edge_ix].to << '\n';

            tree[tree_cnt] = edge(top, v[edge_ix].to, tree_cnt, 1);
            ++tree_cnt;
            q.push(v[edge_ix].to);

        }

    }

}

void dfs_tree(int x) {

    // cout << "dfs tree: " << x << '\n';

    in[x] = ++timer;
    for (int edge_ix = last2[x] ; edge_ix != -1 ; edge_ix = tree[edge_ix].pr)
        dfs_tree(tree[edge_ix].to);

}

string find_reverse(int N, int M, int connections[][2]) {

    fill(last+1, last+N+1, -1);
    fill(last2+1, last2+N+1, -1);

    n = N;
    m = M;
    for (int i = 0 ; i < m ; ++i) {
    
        conn[i][0] = connections[i][0];
        conn[i][1] = connections[i][1];
        v[i] = edge(connections[i][0], connections[i][1], i, 0);
    
    }

    for (int i = 0 ; i < m ; ++i) v[m+i] = edge(connections[i][1], connections[i][0], m+i, 0);
    
    string res(m, '0');
    for (int i = 1 ; i <= n ; ++i) {
    
        if (dist[i]) continue;
        bfs_edges(i);
        timer = 0;
        // cout << "done bfs\n";
        dfs_tree(i);
    
    }

    for (int i = 0 ; i < m ; ++i) {

        if (oriented[i] == 0) {

            if (in[conn[i][0]] < in[conn[i][1]]) oriented[i] = 1;
            else oriented[i] = 2;

        }

        res[i] = '0' + oriented[i] - 1;

    }

    // cerr << "end graph:\n";
    // for (int i = 0 ; i < m ; ++i) {

    //     if (res[i] == '0') cout << connections[i][0] << ' ' << connections[i][1] << '\n';
    //     else cout << connections[i][1] << ' ' << connections[i][0] << '\n';

    // }

    return res;

}
