#include <iostream>
#include <queue>
using namespace std;
const int maxn = 5e5+10, maxm = 15e5+10;

int parent[maxn];
int depth[maxn];

int find_parent(int x) {

    if (x == parent[x]) return x;
    return parent[x] = find_parent(parent[x]);

}

void connect(int x, int y) {

    x = find_parent(x);
    y = find_parent(y);
    if (x == y) return;
    if (depth[x] > depth[y]) swap(x, y);
    if (depth[x] == depth[y]) ++depth[y];
    parent[x] = y;

}

bool connected(int x, int y) {

    return find_parent(x) == find_parent(y);

}

int in[maxn], last[maxn];
int tree_cnt;
int n, m;

struct edge {

    int pr, to;
    edge(){}
    edge(int from, int _to, int _ix) {

        pr = last[from];
        last[from] = _ix;
        to = _to;

    }

} v[2*maxn];

struct node {

    node *next_in;
    int value;

    node(){

        next_in = nullptr;

    }
    node(int _x) {

        value = _x;
        next_in = nullptr;

    }

};

node *start;
node *in_end;

bool dist[maxn];

string find_reverse(int N, int M, int connections[][2]) {

    fill(last+1, last+N+1, -1);

    n = N;
    m = M;

    for (int i = 1 ; i <= n ; ++i) {
        
        depth[i] = 1;
        parent[i] = i;

    }

    int cnt = 0;

    for (int i = 0 ; i < m ; ++i) {

        if (connected(connections[i][0], connections[i][1])) continue;
        v[cnt] = edge(connections[i][0], connections[i][1], cnt);
        ++cnt;
        v[cnt] = edge(connections[i][0], connections[i][1], cnt);
        ++cnt;
        connect(connections[i][0], connections[i][1]);
    
    }
    
    
    string res(m, '0');
    for (int i = 1 ; i <= n ; ++i) {
    
        if (dist[i]) continue;

        start = in_end = new node(i);
        dist[i] = 1;

        while (start != nullptr) {

            int top = start->value;
            
            for (int edge_ix = last[top] ; edge_ix != -1 ; edge_ix = v[edge_ix].pr) {


                if (dist[v[edge_ix].to]) continue;
                dist[v[edge_ix].to] = 1;

                in[v[edge_ix].to] = ++tree_cnt;
                in_end->next_in = new node(v[edge_ix].to);
                in_end = in_end->next_in;

            }

            start = start->next_in;

        }
    
    }

    for (int i = 0 ; i < m ; ++i) {

        if (in[connections[i][0]] < in[connections[i][1]]) res[i] = '0';
        else res[i] = '1';

    }

    // cerr << "end graph:\n";
    // for (int i = 0 ; i < m ; ++i) {

    //     if (res[i] == '0') cout << connections[i][0] << ' ' << connections[i][1] << '\n';
    //     else cout << connections[i][1] << ' ' << connections[i][0] << '\n';

    // }

    return res;

}
