#include <iostream>
#include <unordered_map>
#include <algorithm>
using namespace std;
const int maxn = 1e6+10, maxlog = 15, buff_size = 2e5;
char buff[maxn];
int buff_ix = buff_size-1;

inline void read_char() {

    if (++buff_ix == buff_size) fread(buff, buff_size, 1, stdin), buff_ix = 0;

}

inline void read_int(int &x) {

    x = 0;
    for (; '0' > buff[buff_ix] || buff[buff_ix] > '9'; read_char());
    for (; '0' <= buff[buff_ix] && buff[buff_ix] <= '9'; read_char())
        x = 10*x + buff[buff_ix]-'0';

}

int a[maxn], n;
int b[maxn], m;
pair < int, int > sorteda[maxn];
pair < int, int > sortedb[maxn];
unordered_map < long long, int > prefixes;

inline void solve() {

    for (int i = 1 ; i <= n ; ++i)
        sorteda[i] = {a[i], i};

    for (int i = 1 ; i <= m ; ++i)
        sortedb[i] = {b[i], i};

    sort(sorteda+1, sorteda+1+n);
    sort(sortedb+1, sortedb+1+m);

    long long sum = 0;
    for (int j = 1 ; j <= n ; ++j) {

        sum += sorteda[j].first;
        prefixes[sum] = j;

    }
    
    for (int i = 1 ; i <= m ; ++i) {

        sum = 0;
        for (int j = i ; j <= min(i+maxlog-1, m) ; ++j) {

            sum += sortedb[j].first;
            if (prefixes.count(sum)) {


                int r = prefixes[sum];
                cout << r << '\n';
                for (int curr = 1 ; curr <= r ; ++curr)
                    cout << sorteda[curr].second-1 << ' ';
                cout << '\n';
                cout << j - i+1 << '\n';
                for (int curr = i ; curr <= j ; ++curr)
                    cout << sortedb[curr].second-1 << ' ';
                cout << '\n';
                return;

            }


        }

    } 

    exit(-1);

}

inline void fast_io() {

    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cerr.tie(nullptr);

}

inline void read() {

    read_int(n);
    for (int i = 1 ; i <= n ; ++i) read_int(a[i]);

    read_int(m);
    for (int i = 1 ; i <= m ; ++i) read_int(b[i]);

}

int main () {

    fast_io();
    read();
    solve();

    return 0;

}