#include <iostream>
#include <unordered_map>
#include <algorithm>
using namespace std;
const int maxn = 1e6+10, maxlog = 20, buff_size = 2e5;
char buff[maxn];
int buff_ix = buff_size-1;

inline void read_char() {

    if (++buff_ix == buff_size) fread(buff, buff_size, 1, stdin), buff_ix = 0;

}

inline void read_int(int &x) {

    x = 0;
    for (; '0' > buff[buff_ix] || buff[buff_ix] > '9'; read_char());
    for (; '0' <= buff[buff_ix] && buff[buff_ix] <= '9'; read_char())
        x = 10*x + buff[buff_ix]-'0';

}

int a[maxn], n;
int b[maxn], m;
pair < int, int > sorteda[maxn];
pair < int, int > sortedb[maxn];
unordered_map < long long, int > prefixes;
unordered_map < long long, int > sums;

inline void equal_elements() {

    int l = 1, r = 1;

    while (l <= n && r <= m) {

        if (sorteda[l].first == sortedb[r].first) {

            cout << 1 << '\n' << sorteda[l].second-1 << '\n' << 1 << '\n' << sortedb[r].second-1 << '\n';
            exit(0);

        }

        if (sorteda[l].first < sortedb[r].first) ++l;
        else ++r;

    }

}

inline void equal_sums() {

    long long sum = 0;
    for (int i = 1 ; i <= n ; ++i) sum += a[i];
    for (int i = 1 ; i <= m ; ++i) sum -= b[i];

    if (sum == 0) {

        cout << n << '\n';
        for (int i = 0 ; i < n ; ++i)
            cout << i << ' ';
        cout << '\n';
        cout << m << '\n';
        for (int i = 0 ; i < m ; ++i)
            cout << i << ' ';
        cout << '\n';
        exit(0);

    }

}

inline void two_elements() {

    long long curr = 0;
    for (int i = 1 ; i <= n ; ++i) {

        if (sorteda[i].first != sorteda[i-1].first) curr = 1;
        else ++curr;
        sums[curr * sorteda[i].first] = i - curr + 1;

    }

    curr = 0;
    for (int i = 1 ; i <= m ; ++i) {

        if (sortedb[i].first != sortedb[i-1].first) curr = 1;
        else ++curr;
        if (sums.count(curr * sortedb[i].first)) {

            int l = sums[curr * sortedb[i].first];
            int r = l + (curr * sortedb[i].first)/sorteda[l].first - 1;
            cout << r-l+1 << '\n';
            for (int j = l ; j <= r ; ++j)
                cout << sorteda[j].second-1 << ' ';
            cout << '\n';
            cout << curr << '\n';
            for (int j = i-curr+1 ; j <= i ; ++j)
                cout << sortedb[j].second-1 << ' ';
            cout << '\n';
            exit(0);

        }

    }

}


inline void solve() {

    for (int i = 1 ; i <= n ; ++i)
        sorteda[i] = {a[i], i};

    for (int i = 1 ; i <= m ; ++i)
        sortedb[i] = {b[i], i};

    sort(sorteda+1, sorteda+1+n);
    sort(sortedb+1, sortedb+1+m);
    
    equal_elements();
    equal_sums();
    two_elements();
    exit(-1);

    long long sum = 0;
    for (int j = 1 ; j <= n ; ++j) {

        sum += a[j];
        prefixes[sum] = j;

    }
    
    for (int i = 1 ; i <= m ; ++i) {

        sum = 0;
        for (int j = i ; j <= min(i+maxlog-1, m) ; ++j) {

            sum += b[j];
            if (prefixes.count(sum)) {

                int r = prefixes[sum];
                cout << r << '\n';
                for (int curr = 1 ; curr <= r ; ++curr)
                    cout << curr-1 << ' ';
                cout << '\n';
                cout << j - i+1 << '\n';
                for (int curr = i ; curr <= j ; ++curr)
                    cout << curr-1 << ' ';
                cout << '\n';
                return;

            }


        }

    } 

}

inline void fast_io() {

    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cerr.tie(nullptr);

}

inline void read() {

    read_int(n);
    for (int i = 1 ; i <= n ; ++i) read_int(a[i]);

    read_int(m);
    for (int i = 1 ; i <= m ; ++i) read_int(b[i]);

}

int main () {

    fast_io();
    read();
    solve();

    return 0;

}